/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * ưǥȵǽ
 */

/*
 * Cmemo : Text Editor
 * auto_indent.c - source file for auto indentation
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "ini_file.h"
#include "auto_indent.h"
#include "text_struct.h"


/**************************
   ʰ׼ưǥȵǽ
 **************************/
/* Control Key򲡤ʤReturn Key򲡤ȥǥȤʤ */
/* Ctrl+MǼưǥ Shift+Ctrl+Mǥǥ̵       */
gint auto_indent_cb(GtkWidget *widget, GdkEvent *event, gpointer cur_doc)
{
  gpointer focused_widget;
  GdkEventKey *kevent = (GdkEventKey *)event;
  unsigned char *line_text;
  unsigned char *line_start;
  unsigned int indent_count;
  struct text_struct *doc;
  unsigned char indent_char[256];
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  GtkTextIter ins_iter;
  static int do_indent_flg = 0;

  /* 硼ȥåȥǽλ褦Ȥȥ顼å */
  /* ФΤǡ򤹤ե饰å         */
  if (cm_end_flag == 1) {
    return(FALSE);
  }

  if (cm_im_editting == 1) {
    return(FALSE);
  }

  /*debug*/
  /*printf("state = %d\n", kevent->state);
  printf("keyval = %d\n", kevent->keyval);*/

  if (cur_doc == NULL) {
    if (kevent->keyval == GDK_Return) {
      do_indent_flg = 1;
    }
    else {
      do_indent_flg = 0;
    }
    return(FALSE);
  }
  else { /* cur_doc != NULL */
    if (do_indent_flg == 0) {
      return(FALSE);
    }
    do_indent_flg = 0;
  }

  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  /*եΤ륦ɥΥݥ󥿤򥻥å*/
  if (GTK_WIDGET_HAS_FOCUS(GTK_WIDGET(doc->textbox)) == 1) {
    focused_widget = doc->textbox;
  }
  else {
    return(FALSE);
  }

  /* Ctrl+Mǲ */
  /* (kevent->state == 1)  : Shift          */
  /* (kevent->state == 4)  : Ctrl           */
  /* (kevent->state == 8)  : Alt            */
  /* (kevent->state == 5)  : Shift+Ctrl     */
  /* (kevent->state == 9)  : Shift+Alt      */
  /* (kevent->state == 12) : Ctrl+Alt       */
  /* (kevent->state == 13) : Shift+Ctrl+Alt */
  if ((kevent->state == 4) || (kevent->state == 5)) {
    if ((kevent->keyval == GDK_M) ||(kevent->keyval == GDK_m)) {
//      gtk_text_insert(GTK_TEXT(focused_widget), cm_normal_font,
//                      &cm_base_color, NULL, "\n", strlen("\n"));
      if (kevent->state == 5) {
        return(FALSE);
      }
    }
  }

  /* ưǥOFFξϴؿȴ */
  if (cm_indent_mode == 0) {
    return(FALSE);
  }

  /* ⤷ Ctrl+Return Ƥ鼫ưǥ */
  /* Ԥ鷺˲Ԥƴؿȴ褦ˤ    */
  if (kevent->state == 4) {
    if (kevent->keyval == GDK_Return) {
//      gtk_text_insert(GTK_TEXT(focused_widget), cm_normal_font,
//                      &cm_base_color, NULL, "\n", strlen("\n"));
      return(FALSE);
    }
  }

  /* ꥿󥭡ޤCtrl+MޤCtrl+m */
  if ((kevent->keyval == GDK_Return) || ((kevent->state == 4) && 
      ((kevent->keyval == GDK_M) ||(kevent->keyval == GDK_m)))) {

    /* ΤԤ1ʬ */
    gtk_text_buffer_get_iter_at_mark(buffer,
                                     &start_iter,
                                     gtk_text_buffer_get_mark(buffer, "insert"));
    if (gtk_text_iter_backward_line(&start_iter) == FALSE) {
      return(FALSE);
    }
    gtk_text_iter_set_line_offset(&start_iter, 0);
    memcpy(&end_iter, &start_iter, sizeof(GtkTextIter));
    if (gtk_text_iter_forward_to_line_end(&end_iter) == FALSE) {
      return(FALSE);
    }
    line_text = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
    line_start = line_text;

    /*debug*/
    /*printf("\"%s\"\n", line_start);*/

    indent_count = 0;
    memset(&indent_char[0], 0, sizeof(indent_char));
    while (((int)line_start[indent_count] == (int)' ') ||
           ((int)line_start[indent_count] == (int)'\t')) {
      indent_count++;
    }
    if (indent_count >= sizeof(indent_char)) {
      indent_count = sizeof(indent_char) - 1;
    }
    memcpy(&indent_char[0], line_start, indent_count);

    /*debug*/
    /*printf("\"%s\"\n", indent_char);*/

    if (indent_count != 0) {
      gtk_text_buffer_get_iter_at_mark(buffer,
                                       &ins_iter,
                                       gtk_text_buffer_get_mark(buffer, "insert"));
      gtk_text_buffer_insert(buffer, &ins_iter, indent_char, indent_count);
    }
    g_free(line_text);
  }

  return(FALSE);
}
