/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * BMˡˤʸ󸡺ؿ
 */

/*
 * Cmemo : Text Editor
 * bm_search.c - source file for Boyer-Moore algorithm
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <ctype.h>
#include "bm_search.h"

#define uchar unsigned char

/* matchcase 0 : ʸʸζ̤򤹤         */
/* matchcase 1 : ʸʸξ˥ޥå */

/* Ĺtext_lenʸtextĹpat_lenʸpattern򸡺(BMˡ) */
int bm_search(uchar *text, int text_len, uchar *pattern, int pat_len, int matchcase)
{
  int skip[256]; /* ƥȤȥѥ԰פĤäȤˡɤ餹򼨤 */
  int i; /* ܤƤƥȤΰ֤ɽݥ */
  int j; /* ܤƤѥΰ֤ɽݥ */


  /* ɽskip */
  for (i = 0; i < 256; i++) {
    skip[i] = pat_len;
  }
  if (matchcase == 0) {
    for (i = 0; i < pat_len - 1; i++) {
      skip[pattern[i]] = pat_len - i - 1;
    }
  }
  else {
    for (i = 0; i < pat_len - 1; i++) {
      skip[up_case(pattern[i])] = pat_len - i - 1;
    }
  }

  /* ݥ󥿤롣ѥ˸äӤΤ */
  /* ѥĹ-1˽                                     */
  i = pat_len - 1;

  /* matchcaseȽβ1ˤ(®˽)٤ˡʬ */
  if (matchcase == 0) {
    /* ƥȤκǸ˹ԤޤǷ֤ */
    while (i < text_len) {
      /* ݥjѥκǸʸؤ褦ˤ */
      j = pat_len - 1;

      /* ƥȤȥѥ󤬰פ֤֡ */
      while (text[i] == pattern[j]) {
        /* Ǹʸޤǰפ顢Ǥ */
        if (j == 0) {
          return(i);
        }

        /* ݥij򤽤줾1ʸʬ᤹ */
        i--;
        j--;
      }

      /* פʤäΤǡѥ򤺤餹 */
      i = i + max(skip[text[i]], pat_len - j);
    }
  }
  else {
    /* ƥȤκǸ˹ԤޤǷ֤ */
    while (i < text_len) {
      /* ݥjѥκǸʸؤ褦ˤ */
      j = pat_len - 1;

      /* ƥȤȥѥ󤬰פ֤֡ */
      while (up_case(text[i]) == up_case(pattern[j])) {
        /* Ǹʸޤǰפ顢Ǥ */
        if (j == 0) {
          return(i);
        }

        /* ݥij򤽤줾1ʸʬ᤹ */
        i--;
        j--;
      }

      /* פʤäΤǡѥ򤺤餹 */
      i = i + max(skip[up_case(text[i])], pat_len - j);
    }
  
  }

  /* ɸĤʤä */
  return(-1);
}


/* Ĺtext_lenʸtextĹpat_lenʸpattern(BMˡ) */
int bm_re_search(uchar *text, int text_len, uchar *pattern, int pat_len, int matchcase)
{
  /* ƥȤȥѥ԰פĤäȤˡɤ餹򼨤 */
  int skip[256];
  /* ܤƤƥȤΰ֤ɽݥ */
  int i;
  /* ܤƤѥΰ֤ɽݥ */
  int j;


  /* ɽskip */
  for (i = 0; i < 256; i++) {
    skip[i] = pat_len;
  }
  if (matchcase == 0) {
    for (i = pat_len - 1; i > 0 ; i--) {
      skip[pattern[i]] = i;
    }
  }
  else {
    for (i = pat_len - 1; i > 0 ; i--) {
      skip[up_case(pattern[i])] = i;
    }
  }

  /* ݥ󥿤롣ѥ˸äӤΤ */
  /* ѥĹ-1˽                                     */
  i = text_len - pat_len;

  /* matchcaseȽβ1ˤ(®˽)٤ˡʬ */
  if (matchcase == 0) {
    /* ƥȤƬ˹ԤޤǷ֤ */
    while (i >= 0) {
      /* ݥjѥκǽʸؤ褦ˤ */
      j = 0;

      /* ƥȤȥѥ󤬰פ֤֡ */
      while (text[i] == pattern[j]) {
        /* Ǹʸޤǰפ顢Ǥ */
        if (j == pat_len - 1) {
          return(i - (pat_len - 1));
        }

        /* ݥij򤽤줾1ʸʬʤ */
        i++;
        j++;
      }

      /* פʤäΤǡѥ򤺤餹 */
      i = i - max(skip[text[i]], j + 1);
    }
  }
  else {
    /* ƥȤƬ˹ԤޤǷ֤ */
    while (i >= 0) {
      /* ݥjѥκǽʸؤ褦ˤ */
      j = 0;

      /* ƥȤȥѥ󤬰פ֤֡ */
      while (up_case(text[i]) == up_case(pattern[j])) {
        /* Ǹʸޤǰפ顢Ǥ */
        if (j == pat_len - 1) {
          return(i - (pat_len - 1));
        }

        /* ݥij򤽤줾1ʸʬʤ */
        i++;
        j++;
      }

      /* פʤäΤǡѥ򤺤餹 */
      i = i - max(skip[up_case(text[i])], j + 1);
    }
  }

  /* ɸĤʤä */
  return(-1);
}
