/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * ʸĴɽ˴ؤؿ
 */

/*
 * Cmemo : Text Editor
 * coloron.c - source file for syntax highlighting
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "coloron.h"
#include "linenum.h"
#include "undo.h"
#include "ini_file.h"
#include "interface.h"
#include "kanji_conv.h"
#include "cme_misc.h"
#include "search.h"
#include "bm_search.h"


static int do_apply_color = 0;

/* local declarations */
//static void create_tags(GtkTextBuffer *buffer, gpointer ft_inf);

/******************************************************
   Խ(ץʤɤ)ϥ⡼ɤؤ
 ******************************************************/
void mode_change_cb(GtkWidget *widget, gpointer data)
{
  struct ftype_info *finf;

  finf = (struct ftype_info *)data;
  cm_input_mode = finf->mode_id;
  mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          cm_msg_mode_changed_s,
          finf->mode);
  /*debug*/
  /*printf("mode = %d\n", cm_input_mode);*/
  if (do_apply_color == 1) {
    color_on_cb(widget, data);
  }
  return;
}

/******************************
   ߤΥ⡼ɰɽ
 ******************************/
void show_mode_cb(GtkWidget *widget, gpointer data)
{
  char *ignore_case_buf;
  char *chr_code, *ret_mode;

  chr_code = get_char_code_string(cm_kanji_mode);
  ret_mode = get_return_mode_string(cm_return_mode);

  switch (cm_ignore_case) {
  case 0:
    ignore_case_buf = cm_msg_dont_ignore_case;
    break;
  case 1:
    ignore_case_buf = cm_msg_ignore_case;
    break;
  default :
    ignore_case_buf = cm_msg_ignore_case;
    break;
  }

  mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          cm_msg_mode_message_s1_s2_s3_s4,
          cm_ft_inf[cm_input_mode].mode,
          chr_code, ret_mode,
          ignore_case_buf);

  return;
}

/****************************
   ̤ΥեåԤ
 ****************************/
void refresh_display_cb(GtkWidget *widget, gpointer data)
{
  update_text(data);
  mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          cm_msg_display_refreshed_d,
          get_cur_line_number() + 1);
  return;
}

/****************************
   顼ɽON/OFFԤ
 ****************************/
void syntax_highlighting_cb(GtkWidget *widget, gpointer data)
{
  /* δؿƤФ줿ǥå֤ȿžϤǤ˽äƤ餷 */
  /*gtk_check_menu_item_toggled(GTK_CHECK_MENU_ITEM(widget));*/

  if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(widget)) == TRUE) {
    color_on_cb(widget, data);
  }
  else {
    color_off_cb(widget, data);
  }
  return;
}

/******************************************************
   Ctrl+Lʤɤǲ̤Υ顼ɽեå夹ؿ
 ******************************************************/
void color_on_cb(GtkWidget *widget, gpointer data)
{
//  gchar *textbuf;
  struct text_struct *doc;
//  GtkTextBuffer *buffer;
//  GtkTextIter start_iter;
//  GtkTextIter end_iter;

  do_apply_color = 1;
  /*mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_wait);*/
  doc = &cm_document;
  update_text(doc);
#if 0
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  /* debug */
  /*printf("color_on_cb:buffer=%p\n", buffer);*/
  /*disconnect_document(buffer, doc);*/

  gtk_text_buffer_get_start_iter(buffer, &start_iter);
  gtk_text_buffer_get_end_iter(buffer, &end_iter);
  textbuf = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
  if (textbuf != NULL) {
    /* ʸϤʤƥȤ򥫥顼ɽ */
    apply_color(&start_iter,
                &end_iter,
                buffer,
                textbuf,
                &cm_ft_inf[cm_input_mode],
                0);

    g_free(textbuf);
  }
  /*connect_document(buffer, doc);*/

  /*mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          "syntax highlighting : %s",
          cm_ft_inf[cm_input_mode].mode);*/
#endif
  return;
}

/***********************************************
   Alt+Lʤɤǲ̤Υ顼ɽ̵ˤؿ
 ***********************************************/
void color_off_cb(GtkWidget *widget, gpointer data)
{
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;

  do_apply_color = 0;
  /*mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_wait);*/
  doc = &cm_document;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  /* debug */
  /*printf("color_off_cb:buffer=%p\n", buffer);*/
  /*disconnect_document(buffer, doc);*/

  gtk_text_buffer_get_start_iter(buffer, &start_iter);
  gtk_text_buffer_get_end_iter(buffer, &end_iter);
  /* 顼ɽѤΥƺ */
  gtk_text_buffer_remove_all_tags(buffer, &start_iter, &end_iter);
  gtk_text_buffer_apply_tag_by_name(buffer, "cm_basic_color", &start_iter, &end_iter);
  /*connect_document(buffer, doc);*/

  /*mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          "syntax highlighting : off");*/
  return;
}

/********************************************************************
   ƥȥåȤ˥ƥȤ򥫥顼ɽؿؤδؿ
 ********************************************************************/
void color_on(gpointer textview, gchar *textbuf)
{
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;

  /*do_apply_color = 1;*/
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));

  /* 顼ɽѤΥöƺ(Ⱦ®ʤ롩) */
  gtk_text_buffer_get_start_iter(buffer, &start_iter);
  gtk_text_buffer_get_end_iter(buffer, &end_iter);
  gtk_text_buffer_remove_all_tags(buffer, &start_iter, &end_iter);

  /* ƥȾõ */
  /*gtk_text_buffer_delete(buffer, &start_iter, &end_iter);*/

  /* δؿϴ¸ΥХåեƿХåե */
  /* ɤ߹ǤΤǾƥȺɬפʤ   */
  gtk_text_buffer_set_text(buffer, textbuf, strlen(textbuf));

  /* 顼ɽѤΥ */
  create_tags(buffer, &cm_ft_inf[cm_input_mode]);

  /* ʸϤʤƥȤ򥫥顼ɽ */
  gtk_text_buffer_get_start_iter(buffer, &start_iter);
  gtk_text_buffer_get_end_iter(buffer, &end_iter);
  /*apply_color(&start_iter,
              &end_iter,
              buffer,
              textbuf,
              &cm_ft_inf[cm_input_mode],
              0);*/

  line_number_init_cb(&cm_document);

  return;
}

/********************
 եѤδؿ
 ********************/
void create_tags(GtkTextBuffer *buffer, gpointer ft_inf)
{
  GtkTextTag *tag;
  GtkTextTagTable *tag_table;
  struct ftype_info *finf;

  finf = (struct ftype_info *)ft_inf;

  /* ơ֥ */
  tag_table = gtk_text_buffer_get_tag_table(buffer);

  tag = gtk_text_tag_table_lookup(tag_table, "cm_keyword1_color");
  if (tag != NULL) {
    gtk_text_tag_table_remove(tag_table, tag);
  }
  gtk_text_buffer_create_tag(buffer, "cm_keyword1_color",
                             "family", cm_key_font,
                             "size", cm_font_size * PANGO_SCALE,
                             "style", PANGO_STYLE_NORMAL,
                             "variant", PANGO_VARIANT_NORMAL,
                             "stretch", PANGO_STRETCH_NORMAL,
                             "weight", cm_key_weight,
                             "foreground", finf->keyword1_color,
                             NULL);

  tag = gtk_text_tag_table_lookup(tag_table, "cm_keyword2_color");
  if (tag != NULL) {
    gtk_text_tag_table_remove(tag_table, tag);
  }
  gtk_text_buffer_create_tag(buffer, "cm_keyword2_color",
                             "family", cm_key_font,
                             "size", cm_font_size * PANGO_SCALE,
                             "style", PANGO_STYLE_NORMAL,
                             "variant", PANGO_VARIANT_NORMAL,
                             "stretch", PANGO_STRETCH_NORMAL,
                             "weight", cm_key_weight,
                             "foreground", finf->keyword2_color,
                             NULL);

  tag = gtk_text_tag_table_lookup(tag_table, "cm_basic_color");
  if (tag != NULL) {
    gtk_text_tag_table_remove(tag_table, tag);
  }
  gtk_text_buffer_create_tag(buffer, "cm_basic_color",
                             "family", cm_text_font,
                             "size", cm_font_size * PANGO_SCALE,
                             "style", PANGO_STYLE_NORMAL,
                             "variant", PANGO_VARIANT_NORMAL,
                             "stretch", PANGO_STRETCH_NORMAL,
                             "weight", cm_text_weight,
                             "foreground", finf->basic_color,
                             NULL);

  tag = gtk_text_tag_table_lookup(tag_table, "cm_number_color");
  if (tag != NULL) {
    gtk_text_tag_table_remove(tag_table, tag);
  }
  gtk_text_buffer_create_tag(buffer, "cm_number_color",
                             "family", cm_text_font,
                             "size", cm_font_size * PANGO_SCALE,
                             "style", PANGO_STYLE_NORMAL,
                             "variant", PANGO_VARIANT_NORMAL,
                             "stretch", PANGO_STRETCH_NORMAL,
                             "weight", cm_text_weight,
                             "foreground", finf->number_color,
                             NULL);

  tag = gtk_text_tag_table_lookup(tag_table, "cm_comment_color");
  if (tag != NULL) {
    gtk_text_tag_table_remove(tag_table, tag);
  }
  gtk_text_buffer_create_tag(buffer, "cm_comment_color",
                             "family", cm_text_font,
                             "size", cm_font_size * PANGO_SCALE,
                             "style", PANGO_STYLE_NORMAL,
                             "variant", PANGO_VARIANT_NORMAL,
                             "stretch", PANGO_STRETCH_NORMAL,
                             "weight", cm_text_weight,
                             "foreground", finf->comment_color,
                             NULL);

  tag = gtk_text_tag_table_lookup(tag_table, "cm_string_color");
  if (tag != NULL) {
    gtk_text_tag_table_remove(tag_table, tag);
  }
  gtk_text_buffer_create_tag(buffer, "cm_string_color",
                             "family", cm_text_font,
                             "size", cm_font_size * PANGO_SCALE,
                             "style", PANGO_STYLE_NORMAL,
                             "variant", PANGO_VARIANT_NORMAL,
                             "stretch", PANGO_STRETCH_NORMAL,
                             "weight", cm_text_weight,
                             "foreground", finf->string_color,
                             NULL);

  return;
}

/********************************************
   ʸϤƥƥȤ򥫥顼ɽؿ
 ********************************************/
int
apply_color(GtkTextIter *start,
            GtkTextIter *end,
            GtkTextBuffer *buffer,
            gchar *textbuf,
            gpointer ft_inf,
            int in_comment)
{
  register char *ps;
  register char *pe;
  int i;
  int text_len;
  int flag;
  int cmt_start_len;
  int cmt_end_len;
  int line_cmt_len;
  int rtn_chr_len;
  char *find_pos;
  char key[32];
  int key_ins_flag;
  int key_len;
  int bm_rtn;
  int word_len;
  struct ftype_info *finf;
  GtkTextIter start_iter; /* tokenλϤޤiter */
  GtkTextIter end_iter;   /* tokenνiter */


  if (do_apply_color == 0) {
    return(in_comment);
  }

  finf = (struct ftype_info *)ft_inf;
  ps = textbuf;
  pe = textbuf;
  flag = 0;
  text_len = strlen(textbuf);
  cmt_start_len = strlen(finf->cmt_start);
  cmt_end_len = strlen(finf->cmt_end);
  line_cmt_len = strlen(finf->line_cmt);
  rtn_chr_len = strlen("\n");
  word_len = 0;
  memcpy(&start_iter, start, sizeof(GtkTextIter));
  end_iter = start_iter;

  /* öߤ */
  gtk_text_buffer_begin_user_action(buffer);

  /* 顼ɽѤΥöƺ */
  gtk_text_buffer_remove_all_tags(buffer, start, end);

  while ((*ps != '\0') && (ps < textbuf + text_len)) {
    while ((*pe != '\0') && (ps < textbuf + text_len)) {
      if (in_comment == 1) {
        flag = CME_COMMENT;
        break;
      }
      else if ((memcmp(pe, finf->cmt_start, cmt_start_len) == 0) &&
          (cmt_start_len != 0)) {
        in_comment = 1;
        flag = CME_COMMENT;
        break;
      }
      else if ((memcmp(pe, finf->line_cmt, line_cmt_len) == 0) &&
               (line_cmt_len != 0)) {
        flag = CME_LINE_COMMENT;
        break;
      }
      else if (*pe == finf->str_start) {
        flag = CME_STRING;
        break;
      }
      else if (*pe == finf->chr_start) {
        flag = CME_CHARACTER;
        break;
      }
      else if ((*pe >= '0') && (*pe <= '9')) {
        flag = CME_NUMBER;
        break;
      }
      else if (strchr(finf->delimiter, *pe) != NULL) {
        flag = CME_DELIMITER;
        break;
      }
      else {
       pe++;
      }
    }

    key_len = pe - ps;
    key_ins_flag = 0;
    /* ɤ⤷ʤ */
    if ((key_len < sizeof(key)) && (key_len > 0)) {
      memset(key, 0, sizeof(key));
      memcpy(key, ps, key_len);

      /* ɣǤХ顼ɽ */
      if (key_ins_flag == 0) {
        find_pos = finf->key1buf;
        do {
          bm_rtn = bm_search(find_pos, strlen(find_pos), key, key_len,
                             finf->ignore_case);
          if (bm_rtn > -1) {
            find_pos = find_pos + bm_rtn;
            if (((find_pos == finf->key1buf) || (*(find_pos - 1) == ';')) &&
                ((*(find_pos + key_len) == ';') ||
                 (*(find_pos + key_len) == '\0'))) {
              word_len = get_char_count(key, key_len);
              gtk_text_iter_forward_chars(&end_iter, word_len);
              gtk_text_buffer_apply_tag_by_name(buffer,
                                                "cm_keyword1_color",
                                                &start_iter,
                                                &end_iter);
              key_ins_flag = 1;
              break;
            }
          }
          else {
            break;
          }
          find_pos++;
        } while (1);
      }

      /* ɣǤʤɣǤХ顼ɽ */
      if (key_ins_flag == 0) {
        find_pos = finf->key2buf;
        do {
          bm_rtn = bm_search(find_pos, strlen(find_pos), key, key_len,
                             finf->ignore_case);
          if (bm_rtn > -1) {
            find_pos = find_pos + bm_rtn;
            if (((find_pos == finf->key2buf) || (*(find_pos - 1) == ';')) &&
                ((*(find_pos + key_len) == ';') ||
                 (*(find_pos + key_len) == '\0'))) {
              word_len = get_char_count(key, key_len);
              gtk_text_iter_forward_chars(&end_iter, word_len);
              gtk_text_buffer_apply_tag_by_name(buffer,
                                                "cm_keyword2_color",
                                                &start_iter,
                                                &end_iter);
              key_ins_flag = 1;
              break;
            }
          }
          else {
            break;
          }
          find_pos++;
        } while (1);
      }
    }

    /* ɤǤϤʤ */
    if (key_ins_flag == 0) {
      word_len = get_char_count(ps, key_len);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_basic_color",
                                       &start_iter,
                                       &end_iter);
    }
    ps = pe;
    start_iter = end_iter;

    /* ե饰ͤˤäƽʬ */
    switch (flag) {
    case CME_COMMENT:
      bm_rtn = bm_search(ps, strlen(ps), finf->cmt_end, cmt_end_len, 0);
      if (bm_rtn > -1) {
        in_comment = 0;
        pe = pe + bm_rtn + cmt_end_len;
      }
      else {
        pe = pe + strlen(ps);
      }
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_comment_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    case CME_LINE_COMMENT:
      bm_rtn = bm_search(ps, strlen(ps), "\n", rtn_chr_len, 0);
      if ((bm_rtn > -1)) {
        pe = pe + bm_rtn + rtn_chr_len;
      }
      else {
        pe = pe + strlen(ps);
      }
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_comment_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    case CME_STRING:
      while (*pe != '\0') {
        pe++;
        if (*pe == finf->str_end) {
          i = 0;
          while ((*(pe - i - 1) == finf->esc_chr) && ((pe - i - 1) >= textbuf)) {
            i++;
          }
          if ((i % 2) == 0) {
            pe++;
            break;
          }
        }
      }
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_string_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    case CME_CHARACTER:
      while (*pe != '\0') {
        pe++;
        if (((*pe == finf->chr_end) && (*(pe - 1) != finf->esc_chr)) ||
            ((*pe == finf->chr_end) && (*(pe - 1) == finf->esc_chr) &&
             (*(pe - 2) == finf->esc_chr))) {
          pe++;
          break;
        }
      }
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_number_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    case CME_NUMBER:
      while (*pe != '\0') {
        pe++;
        if ((*pe < '0') || (*pe > '9')) {
          break;
        }
      }
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_number_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    case CME_DELIMITER:
      while (*pe != '\0') {
        pe++;
        if ((strchr(finf->delimiter, *pe) == NULL) ||
            (*pe == finf->cmt_start[0]) ||
            (*pe == finf->line_cmt[0]) ||
            (*pe == finf->str_start) ||
            (*pe == finf->chr_start)){
          break;
        }
      }
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_basic_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    default:
      word_len = get_char_count(ps, pe - ps);
      gtk_text_iter_forward_chars(&end_iter, word_len);
      gtk_text_buffer_apply_tag_by_name(buffer,
                                       "cm_basic_color",
                                       &start_iter,
                                       &end_iter);
      ps = pe;
      start_iter = end_iter;
      break;
    }
  }
  /* Ƴ */
  gtk_text_buffer_end_user_action(buffer);
  return(in_comment);
}

int update_text(gpointer cur_doc)
/*static int update_text(gpointer cur_doc)*/
{
  struct text_struct *doc;
  GdkRectangle rect;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  gchar *textbuf;
  int bm_rtn_cmt_start;
  int bm_rtn_cmt_end;
  int in_comment;


  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  gtk_text_view_get_visible_rect(GTK_TEXT_VIEW(doc->textbox), &rect);
  gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(doc->textbox),
                                     &start_iter,
                                     rect.x,
                                     rect.y);
  gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(doc->textbox),
                                     &end_iter,
                                     rect.x + rect.width,
                                     rect.y + rect.height);
  textbuf = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
  if (textbuf != NULL) {
    /* debug */
    /*printf("update_text called!\n");*/
    bm_rtn_cmt_start = bm_search(textbuf,
                                 strlen(textbuf),
                                 cm_ft_inf[cm_input_mode].cmt_start,
                                 strlen(cm_ft_inf[cm_input_mode].cmt_end),
                                 0);
    bm_rtn_cmt_end = bm_search(textbuf,
                               strlen(textbuf),
                               cm_ft_inf[cm_input_mode].cmt_end,
                               strlen(cm_ft_inf[cm_input_mode].cmt_end),
                               0);
    if (bm_rtn_cmt_end != -1) {
      if (bm_rtn_cmt_start > bm_rtn_cmt_end) {
        in_comment = 1;
      }
      else if (bm_rtn_cmt_start == -1) {
        in_comment = 1;
      }
      else {
        in_comment = 0;
      }
    }
    else {
      in_comment = 0;
    }
    in_comment = apply_color(&start_iter,
                             &end_iter,
                             buffer,
                             textbuf,
                             &cm_ft_inf[cm_input_mode],
                             in_comment);
    g_free(textbuf);
  }
  return(0);
}
