/*
 * GTK+(2.x.x)ѤPC-UNIXѥĢΥ
 *
 * եΥץ󥻡֤˴ؤؿ
 */

/*
 * Cmemo : Text Editor
 * files.c - source file for loading or saving files
 *
 * Copyright (C) 2000 - 2004, 2005 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include "cme_def.h"
#include "cmemo.h"
#include "coloron.h"
#include "files.h"
#include "linenum.h"
#include "undo.h"
#include "ini_file.h"
#include "interface.h"
#include "warning.h"
#include "kanji_conv.h"
#include "cme_misc.h"
#include "utf8.h"
#include "text_struct.h"


int cm_input_mode; /* ϥ⡼(C C++ etc)(cm_ft_inf[]ֹ) */
int cm_kanji_mode; /* ⡼(euc-jp etc)(cm_km_inf[]ֹ) */
int cm_return_mode; /* ʸμ(CR LF CRLF)ɽХѿ */
struct ftype_info cm_ft_inf[FTYPE_INFO_MAX]; /* ϥ⡼ɤ빽¤ */
struct kmode_info cm_km_inf[KMODE_INFO_MAX]; /* ⡼ɤ빽¤ */

static int load_type = AUTOMATIC; /* ɤ߹ʸɼưȽ̤ɤ */
static struct file_open_struct fo; /* ե륪ץ¤ */

/* local declarations */
//static gchar *cm_filename_from_utf8(gchar *);
static gchar *cm_filename_to_utf8(gchar *);
static int get_file_type(char *dot);
static void what_file(GtkWidget *widget, gpointer cur_doc);
static int convert_to_utf8(unsigned char **buf, int buf_size);
static int convert_from_utf8(unsigned char **buf, int buf_size);
static int file_save(char *save_fname, gpointer cur_doc);
static void cancel_cb(GtkWidget *widget, gpointer data);
static void destroy_cb(GtkWidget *widget, gpointer data);
static int ok_cb_open(GtkWidget *widget, gpointer textview,
                      gchar *filename, int file_type);
static void ok_cb_save(GtkWidget *widget, gpointer cur_doc);
static void open_hex(gpointer textview, unsigned char *fname);


char *get_char_code_string(int code_idx)
{
  int i;
  int kanji_idx;

  kanji_idx = 0;
  for (i = 0; i < KMODE_INFO_MAX; i++) {
    if (cm_km_inf[i].mode_id == code_idx) {
      kanji_idx = i;
      break;
    }
  }
  return(cm_km_inf[kanji_idx].title);
}

/**********************************************
   ԽΥեʸɤؤ
 **********************************************/
void set_kanji_mode(GtkWidget *widget, gpointer data)
{
  struct kmode_info *kinf;

  kinf = (struct kmode_info *)data;
  cm_kanji_mode = kinf->mode_id;
  mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          cm_msg_changed_kanji_code_s,
          kinf->title);
  set_status_char_code(kinf->title);

  /* ʸɤꤷϼΥեɤ߹߻˼ưȽ̤򤷤ʤ */
  /* MANUALǰɤ߹load_typeAUTOMATICˤɤ */
  load_type = MANUAL;

  return;
}

char *get_return_mode_string(int mode)
{
  char *code;

  switch (mode) {
  case CME_LF:   code = cm_msg_return_code_lf;   break;
  case CME_CR:   code = cm_msg_return_code_cr;   break;
  case CME_CRLF: code = cm_msg_return_code_crlf; break;
  default :      code = cm_msg_return_code_lf;   break;
  }
  return(code);
}

/********************************************
   ԽΥեβʸؤ
 ********************************************/
void set_return_mode(GtkWidget *widget, gpointer mode)
{
  char *code;

  cm_return_mode = (int)mode;
  code = get_return_mode_string(cm_return_mode);
  mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_changed_return_code_s, code);
  set_status_return_mode(code);
  return;
}
#if 0
/* ե̾Υ󥳡ǥ󥰤UTF-8饷ƥΥɤѴ */
static gchar *cm_filename_from_utf8(gchar *fname)
{
  gchar *s;
  const gchar *charset;

  if (g_get_charset(&charset)) {
    /* ͤξcharsetUTF-8 */
    return(g_strdup(fname));
  }
  s = g_convert(fname, -1, charset, "UTF-8", NULL, NULL, NULL);
  if (s == NULL) {
    int tmpcode = cm_kanji_mode;
    int len = strlen(fname) + 1;
    s = g_malloc(len);
    if (s) {
      strcpy(s, fname);
#ifdef WINCMEMO
      /* WindowsѤν֥ԡ  ե̾.txtפΤ褦  */
      /* ʸ˥СȤǤʤΤǤȤꤢSJISѴ */
      cm_kanji_mode = SHIFT_JIS;
#else
      /* PC-UNIXξ硢ȤꤢEUCˤƤ */
      cm_kanji_mode = EUC_JP;
#endif
      /* ϥ顼å򤷤ʤȤʤ... */
      convert_from_utf8((unsigned char **)&s, len);
      cm_kanji_mode = tmpcode;
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
    }
  }
  return(s);
}
#endif
/* ե̾Υ󥳡ǥ󥰤򥷥ƥΥɤUTF-8Ѵ */
static gchar *cm_filename_to_utf8(gchar *fname)
{
  gchar *s;
  const gchar *charset;

  if (g_get_charset(&charset)) {
    /* ͤξcharsetUTF-8 */
    return(g_strdup(fname));
  }
  s = g_convert(fname, -1, "UTF-8", charset, NULL, NULL, NULL);
  if (s == NULL) {
    int tmpcode = cm_kanji_mode;
    int len = strlen(fname) + 1;
    s = g_malloc(len);
    if (s) {
      strcpy(s, fname);
#ifdef WINCMEMO
      /* WindowsѤν֥ԡ  ե̾.txtפΤ褦  */
      /* ʸ˥СȤǤʤΤǤȤꤢSJISѴ */
      cm_kanji_mode = SHIFT_JIS;
#else
      /* PC-UNIXξ硢ȤꤢEUCˤƤ */
      cm_kanji_mode = EUC_JP;
#endif
      load_type = MANUAL;
      /* ϥ顼å򤷤ʤȤʤ... */
      convert_to_utf8((unsigned char **)&s, len);
      cm_kanji_mode = tmpcode;
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
    }
  }
  return(s);
}

/**************************************************
   ˥ե뤬ɥåפ줿ޤϥ
   ɥ饤ǥե̾ꤵ줿ν
 **************************************************/
void file_open(gpointer cur_doc, gchar *fname)
{
  struct text_struct *doc;
  struct stat stbuf;

  doc = cur_doc;
  doc->filename = fo.filename;
  /* fo.filenameƤfo.tmpfilename˰ö򤹤 */
  memcpy(fo.tmpfilename, fo.filename, sizeof(fo.tmpfilename));
  if (stat(fname, &stbuf) == -1) {
    /* 򤷤ƤǡѤƥե̾򸵤᤹ */
    /*memcpy(fo.filename, fo.tmpfilename, sizeof(fo.filename));*/
    mlwrite(ML_BOTH,
            ML_IMMEDIATELY,
            cm_msg_file_not_found_s,
            fname);
    return;
  }
  strcpy(doc->filename, fname);

  what_file(NULL, cur_doc);

  return;
}

/********************************************************
   ftype_info¤Τ򥵡ƥե륿פꤹ
 ********************************************************/
static int get_file_type(char *dot)
{
  int i;
  char *find_pos;

  for (i = 0; i < FTYPE_INFO_MAX; i++) {
    find_pos = cm_ft_inf[i].ext;
    if (find_pos == NULL) {
      continue;
    }
    do {
      find_pos = strstr(find_pos, dot);
      if (find_pos != NULL) {
        if ((*(find_pos + strlen(dot)) == ';') ||
            (*(find_pos + strlen(dot)) == '\0')) {
          return(i);
        }
      }
      else {
        break;
      }
      find_pos++;
    } while (1);
  }
  return(0);
}

/************************************************************
   ե򳫤ν򤷡ok_cb_open򥳡뤹ؿ
 ************************************************************/
static void what_file(GtkWidget *widget, gpointer cur_doc)
{
  char *tmp;
  pid_t cme_pid;
  char pid_buf[32];
  int check_rtn;
  int open_rtn;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
//  gchar *pbufsys;

  doc = (struct text_struct *)cur_doc;

  if (widget != NULL) {
    /* widgetNULLǤʤȤȤϥץOK줿 */
    /* fo.filenameƤfo.tmpfilename˰ö򤹤 */
    memcpy(fo.tmpfilename, fo.filename, sizeof(fo.tmpfilename));
    doc->filename = fo.filename;
    strcpy(doc->filename,
           gtk_file_selection_get_filename(GTK_FILE_SELECTION(fo.open_dlg)));
    cancel_cb(NULL, NULL);

//    pbufsys = cm_filename_from_utf8(doc->filename);
//    if (pbufsys) {
//      strcpy(doc->filename, pbufsys);
//      g_free(pbufsys);
//    }

    /* ե뤬˳Ƥ뤫ɤå */
    if (strlen(doc->filename) > 0) {
      /* ȤΥץID */
      cme_pid = getpid();
      sprintf(&pid_buf[0], "%d", (int)cme_pid);
      /* ¹cmemoˤäopen_file_nameȰפ  */
      /* ̾Υե뤬˳Ƥ뤫å */
      check_rtn = check_process(&pid_buf[0], doc->filename, "-G0");
      if (check_rtn > 0) {
        /* Ǥ˥ե뤬ƤΤǤǤϳʤ */
        mlwrite(ML_BOTH,
                ML_IMMEDIATELY,
                cm_msg_file_already_opened_s,
                doc->filename);
        /* 򤷤ƤǡѤƥե̾򸵤᤹ */
        memcpy(fo.filename, fo.tmpfilename, sizeof(fo.filename));
        return;
      }
    }
  }

  mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_wait);

  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  disconnect_document(buffer, doc);

  tmp = strrchr(doc->filename, '.');

  /* ĥҤˤäƥեΥפȽ̤ */
  if (tmp != NULL) {
    cm_input_mode = get_file_type(tmp);
  }
  else {
    cm_input_mode = 0;
  }

  /* üޤ֤ɤ */
  set_cme_line_wrap(cm_ft_inf[cm_input_mode].line_wrap);

  /* ե򳫤 */
  open_rtn = ok_cb_open(widget, doc->textbox, doc->filename, cm_input_mode);
  if (open_rtn == 0) {
    scrollbar_update(doc, 0, NULL);
  }
  else {
    /* 򤷤ƤǡѤƥե̾򸵤᤹ */
    memcpy(fo.filename, fo.tmpfilename, sizeof(fo.filename));
    connect_document(buffer, doc);
    return;
  }

  doc->undolist = undo_list_delete(doc->undolist);
  doc->undotail = NULL;
  doc->redolist = undo_list_delete(doc->redolist);
  doc->redotail = NULL;

  connect_document(buffer, doc);

  return;
}

/*******************************************************
   ƥȤUTF-8ѴΥХåե򺹤ؤ
 *******************************************************/
static int convert_to_utf8(unsigned char **buf, int buf_size)
{
  unsigned char *tmp;

  if (load_type == AUTOMATIC) {
    /* ʸɤȽꤹ */
    cm_kanji_mode = what_kanji_code(*buf);
    set_status_char_code(get_char_code_string(cm_kanji_mode));
  }
  else {
    /* ʸɻɤ߹硢ɤ߹߻ˤϼư᤹ */
    load_type = AUTOMATIC;
  }

  /* UTF-8ʳܸξöEUC_JPѴ */
  switch (cm_kanji_mode) {
  case EUC_JP:
    /* ³ */
    break;
  case SHIFT_JIS:
    /* Shift-JisȾѲ̾ʸä硢EUCǤϣܤΰ褬ɬ */
    tmp = (unsigned char *)g_malloc((unsigned)(buf_size * 2));
    if (tmp != NULL) {
      memset(tmp, 0, buf_size * 2);
      sjis_to_euc(tmp, *buf);
      g_free(*buf);
      *buf = tmp;
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
      return(-1);
    }
    break;
  case JIS2022:
    /* JISɤξ硢ѴEUCJIS¿ΰȤȤϤʤ */
    tmp = (unsigned char *)g_malloc((unsigned)buf_size);
    if (tmp != NULL) {
      memset(tmp, 0, buf_size);
      jis_to_euc(tmp, *buf);
      g_free(*buf);
      *buf = tmp;
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
      return(-1);
    }
    break;
  case UTF_8:
    /* UTF-8ξϤΤޤｪλ */
    return(0);
    break;
  case ASCII:
    /* ASCIIξ⤽Τޤｪλ */
    return(0);
    break;
  default :
    /* ꤨʤϤ... */
    break;
  }

  /* öEUC_JPѴ줿ɤ򤳤UTF-8Ѵ */
  /* EUCUTF-8ѴȤ(CJKʸξ)ΰ */
  /* 2ܤнʬǤ                               */
  tmp = (unsigned char *)g_malloc(buf_size * 2);
  if (tmp != NULL) {
    memset(tmp, 0, buf_size * 2);
    utf8_main("-eu", *buf, tmp);
    g_free(*buf);
    *buf = tmp;
  }
  else {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
    return(-1);
  }
  return(0);
}

/***********************************************************************
   ƥȤUTF-8¸ѥɤѴΥХåե򺹤ؤ
 ***********************************************************************/
static int convert_from_utf8(unsigned char **buf, int buf_size)
{
  unsigned char *tmp;
  int len;

  /* ASCII⡼ɤξ¸륳ɤEUCɤĴ٤ */
  if (cm_kanji_mode == ASCII) {
    /* ʸûShift-JisȸǧΤ */
    /* ASCIIǤʤEUC˺ؤ(ǥեȤEUC)   */
    if (what_kanji_code(*buf) != ASCII) {
      cm_kanji_mode = EUC_JP;
    }
  }
  set_status_char_code(get_char_code_string(cm_kanji_mode));

  /* ASCIIޤUTF-8ʤФΤޤｪλ */
  if ((cm_kanji_mode == ASCII) || (cm_kanji_mode == UTF_8)) {
    return(0);
  }

  /* Gtk+2.0ǰʸUTF-8ʤΤǤǰöEUCѴ  */
  /* UTF-8ʤ(CJKʸξ)ѴEUCUTF-8¿ */
  /* ΰȤȤϤʤ                               */
  tmp = (unsigned char *)g_malloc((unsigned)buf_size);
  if (tmp != NULL) {
    memset(tmp, 0, buf_size);
    utf8_main("-ue", *buf, tmp);
    g_free(*buf);
    *buf = tmp;
  }
  else {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
    return(-1);
  }

  /* ̥ʸäĹ */
  len = strlen(*buf) + 1;

  switch (cm_kanji_mode) {
  case EUC_JP:
    /* ³ */
    break;
  case SHIFT_JIS:
    /* EUCShift-JisѴϸΰۤ뤳Ȥ̵ */
    tmp = (unsigned char *)g_malloc(len);
    if (tmp != NULL) {
      memset(tmp, 0, len);
      euc_to_sjis(tmp, *buf);
      g_free(*buf);
      *buf = tmp;
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
      return(-1);
    }
    break;
  case JIS2022:
    /* JisEUCѴ硢ɤΰѰդɤ */
    /* ԳʤΤǡeuc_to_jis򥳡뤹euc_to_jis_size  */
    /* 򥳡뤷ɬפΰĴ٤ʤФʤʤ             */
    /* NULLʸХʬ˺ʤ褦len˲äƤ          */
    len = euc_to_jis_size(*buf) + 1;
    tmp = (unsigned char *)g_malloc(len);
    if (tmp != NULL) {
      memset(tmp, 0, len);
      euc_to_jis(tmp, *buf);
      g_free(*buf);
      *buf = tmp;
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
      return(-1);
    }
    break;
  case UTF_8:
    /* returnƤΤǤ뤳ȤϤʤ */
    break;
  case ASCII:
    /* returnƤΤǤ뤳ȤϤʤ */
    break;
  default :
    /* ꤨʤϤ... */
    break;
  }
  return(0);
}

/********************************************************************************
   ե򳫤ƥȥåȤɽ롢ޤcolor_on򥳡뤹ؿ
 ********************************************************************************/
static int
ok_cb_open(GtkWidget *widget, gpointer textview, gchar *filename, int file_type)
{
  FILE *fp;
  unsigned char *buf;
  struct stat stbuf;
  int size;
  unsigned int new_len;
  int i;
  GtkTextBuffer *buffer;
  gchar *pbufutf;


  /* freadΤ˳"rb"(Хʥ)ǳ */
  if ((fp = fopen(filename, "rb")) != NULL) {
    /* եޤ뤴ȥɤ߹ǥƥȥåȤ˥å */
    /* ե륹ȥ꡼फ飱Ԥɤ߹ˡ¿ΥȤ */
    if (stat(filename, &stbuf) != -1) {
      size = stbuf.st_size + 1; /* ̥ʸʬ */
    }
    else {
      fclose(fp);
      return(-1);
    }

    /* ե륵ʬ */
    buf = (unsigned char *)g_malloc((unsigned)size);

    if (buf != NULL) {
      memset(buf, 0, size);
      /* Хåե˥ƥȥեɤ߹ */
      /* ̥ʸʬäʤ褦˵դ */
      /*fread(buf, sizeof(char), size - 1, fp);*/
      fread(buf, 1, size - 1, fp);

      if (convert_to_utf8(&buf, size) != 0) {
        g_free(buf);
        fclose(fp);
        return(-1);
      }

      /* ƤβʸLFѴ */
      cm_return_mode = all_to_lf(buf);
      set_status_return_mode(get_return_mode_string(cm_return_mode));

      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));

      /* 礭ʥեξ */
      if (size > CME_READ_LIMIT) {
        /* warning()ƤӽФȲΤ */
        /* warning()gtk_main()ιԤ */
        /* ϸ(2001/08/18)ǤǤ */
        /*i = warning(cm_msg_file_size_warning);*/
        i = 1;
        if (i == 1) {
            gtk_text_buffer_set_text (buffer, buf, strlen(buf));
        }
        else {
          /*ƥȥåȤ˥ƥȤ򥫥顼ɽؿ򥳡 */
          color_on(GTK_TEXT_VIEW(textview), buf);
        }
      }
      else {
        /*ƥȥåȤ˥ƥȤ򥫥顼ɽؿ򥳡 */
        color_on(GTK_TEXT_VIEW(textview), buf);
      }

      /* ɤ߹ƥȥǡ꤫鳫 */
      g_free(buf);

      /*եĤ*/
      fclose(fp);
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
      fclose(fp);
      return(-1);
    }

    new_len = gtk_text_buffer_get_char_count(buffer);
    /* debug */
    /*printf("new_len = %d\n", new_len);*/

    pbufutf = cm_filename_to_utf8(cm_document.filename);

    if ((new_len != 0) && ((size >> 2) <= new_len)) {
      /*ߥ˥Хåե˥ե̾ɽ*/
      if (pbufutf) {
        mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_opened_s, pbufutf);
      }
      else {
        mlwrite(ML_BOTH,
                ML_IMMEDIATELY,
                cm_msg_file_opened_s,
                cm_document.filename);
      }
    }
    else {
      /* sizeͤ(ե륵+1)ʤΤǡ */
      /* 1ʲʤХե륵0Ǥ   */
      if (size > 1) {
        set_cme_line_wrap(0);
        set_cme_line_numbers(0);
        set_cme_syntax_highlighting(0);
        open_hex(textview, (unsigned char *)filename);
        cm_kanji_mode = BINARY;
        set_status_char_code(get_char_code_string(cm_kanji_mode));
      }
      else {
        if (pbufutf) {
          mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_empty_s, pbufutf);
        }
        else {
          mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_empty_s, filename);
        }
      }
    }

    /*ɥ˥ե̾ɽ*/
    if (pbufutf) {
      gtk_window_set_title(GTK_WINDOW(cm_window), pbufutf);
      g_free(pbufutf);
    }
    else {
      gtk_window_set_title(GTK_WINDOW(cm_window), cm_document.filename);
    }

    /* Կ */
    line_number_init_cb(&cm_document);

    /* ̤б֤ͤ */
    init_kakko_count();

    /* Խѥե饰 */
    cm_document.modified = FALSE;
  }
  else {
    /* ե륪ץ˼ */
    pbufutf = cm_filename_to_utf8(cm_document.filename);
    if (pbufutf) {
      mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_open_error_s, pbufutf);
      g_free(pbufutf);
    }
    else {
      mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_open_error_s, filename);
    }
    return(-1);
  }
  return(0);
}

/**********************
   ե¸
 **********************/
static int file_save(char *save_fname, gpointer cur_doc)
{
  FILE *fp;
  unsigned char *buf;
  unsigned char *tmp;
  unsigned int len;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  gchar *pbufutf;


  buf = NULL;
  tmp = NULL;
  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));

  /*fwriteΤ˳"wb"(Хʥ)ǳ*/
  if ((fp = fopen(save_fname, "wb")) != NULL) {
    gtk_text_buffer_get_start_iter(buffer, &start_iter);
    gtk_text_buffer_get_end_iter(buffer, &end_iter);
    buf = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);

    if (buf == NULL) {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
      fclose(fp);
      return(-1);
    }

    /* NULLʸХʬ˺ʤ褦len˲äƤ */
    len = strlen(buf) + 1;

    if (convert_from_utf8(&buf, len) != 0) {
      g_free(buf);
      fclose(fp);
      return(-1);
    }

    /* ʸѴĹƼ */
    len = strlen(buf) + 1;

    switch (cm_return_mode) {
    case CME_LF:
      break;
    case CME_CR:
      lf_to_cr(buf);
      break;
    case CME_CRLF:
      tmp = (unsigned char *)g_malloc(len + cm_all_lines);
      if (tmp != NULL) {
        memset(tmp, 0, len + cm_all_lines);
        lf_to_crlf(tmp, buf);
        g_free(buf);
        buf = tmp;
      }
      else {
        mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_memory_full);
        g_free(buf);
        fclose(fp);
        return(-1);
      }
      break;
    default :
      break;
    }

    /* ե˽񤭹 */
    /*fwrite(buf, sizeof(unsigned char), strlen(buf), fp);*/
    fwrite(buf, 1, strlen(buf), fp);

    g_free(buf);

    /*եĤ*/
    fclose(fp);

    cm_document.modified = FALSE;

    pbufutf = cm_filename_to_utf8(doc->filename);
    if (pbufutf) {
      mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_wrote_s, pbufutf);
      gtk_window_set_title(GTK_WINDOW(cm_window), pbufutf);
      g_free(pbufutf);
    }
    else {
      mlwrite(ML_BOTH,
              ML_IMMEDIATELY,
              cm_msg_file_wrote_s,
              cm_document.filename);
      gtk_window_set_title(GTK_WINDOW(cm_window), cm_document.filename);
    }
  }
  else {
    pbufutf = cm_filename_to_utf8(doc->filename);
    if (pbufutf) {
      mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_save_error_s, pbufutf);
      g_free(pbufutf);
    }
    else {
      mlwrite(ML_BOTH,
              ML_IMMEDIATELY,
              cm_msg_file_save_error_s,
              cm_document.filename);
    }
    return(-1);
  }
  return(0);
}

/****************************************************
   Save as OKå줿Ȥν
 ****************************************************/
static void ok_cb_save(GtkWidget *widget, gpointer cur_doc)
{
  struct stat stbuf;
  int i;
//  gchar *pbufutf;

  /*ʸɻɤ߹Ǥ硢ɤ߹ߤϼưˤʤ褦ˤ*/
  load_type = AUTOMATIC;

  /* fo.filenameƤfo.tmpfilename˰ö򤹤 */
  memcpy(fo.tmpfilename, fo.filename, sizeof(fo.tmpfilename));
  cm_document.filename = fo.filename;
  strcpy(cm_document.filename,
         gtk_file_selection_get_filename(GTK_FILE_SELECTION(fo.open_dlg)));

//  pbufutf = cm_filename_from_utf8(cm_document.filename);
//  if (pbufutf) {
//    strcpy(cm_document.filename, pbufutf);
//    g_free(pbufutf);
//  }

  if (stat(cm_document.filename, &stbuf) != -1) {
    i = warning(cm_msg_overwrite_warning);
    if (i == 1) {
      /* 򤷤ƤǡѤƥե̾򸵤᤹ */
      memcpy(fo.filename, fo.tmpfilename, sizeof(fo.filename));
      return;
    }
  }
  cancel_cb(NULL, NULL);
  file_save(cm_document.filename, cur_doc);
  return;
}

/***************
   ¸
 ***************/
void save_text(GtkWidget *widget, gpointer cur_doc)
{
  /*struct stat stbuf;*/

  /*Хʥե򳫤Ƥޤä˸äƾ񤭤ʤ褦ˤ*/
  if (cm_kanji_mode == BINARY) {
    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            cm_msg_binary_file_warning);
    return;
  }

  if (cm_document.modified == FALSE) {
    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            cm_msg_no_changes_need_to_be_saved);
    return;
  }

  /* ¸ޤϥե̾դ¸ */
  if (cm_document.filename == NULL) {
    /* ե̾ؤΥݥ󥿤NULLξ */
    save_as_text(widget, cur_doc);
  }
  else if (strlen(cm_document.filename) == 0) {
    /* ե̾Ĺ0ξ */
    save_as_text(widget, cur_doc);
  }
  /*else if (stat(cm_document.filename, &stbuf) == -1) {*/
    /* ꤵ줿̾Υե뤬¸ߤʤ */
    /* cmemoǳƤ˺ʤ¤ꤢʤ */
    /*save_as_text(widget, cur_doc);*/
  /*}*/
  else {
    file_save(cm_document.filename, cur_doc);
  }

  return;
}

/************************************************
   Cancelå줿Ȥν
 ************************************************/
static void cancel_cb(GtkWidget *widget, gpointer data)
{
  gtk_grab_remove(fo.open_dlg);
  gtk_widget_destroy(fo.open_dlg);
  return;
}

/********************************
   ˴ν
 ********************************/
static void destroy_cb(GtkWidget *widget, gpointer data)
{
  gtk_main_quit();
  return;
}

/*************************
   Open ɽ
 *************************/
void open_text(GtkWidget *widget, gpointer cur_doc)
{
  int i;
  int x;
  int y;
  int width;
  int height;
  int dlg_width;
  int dlg_height;
  int dlg_pos_x;
  int dlg_pos_y;

  if (cm_document.modified == TRUE) {
    i = warning(cm_msg_newtext_warning);
    if (i == 1) {
      return;
    }
  }

  fo.open_dlg = gtk_file_selection_new("Open file");

  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(fo.open_dlg));

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->ok_button),
                     "clicked",
                     GTK_SIGNAL_FUNC(what_file),
                     cur_doc);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->cancel_button),
                     "clicked",
                     GTK_SIGNAL_FUNC(cancel_cb),
                     NULL);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)),
                     "destroy",
                     GTK_SIGNAL_FUNC(destroy_cb),
                     NULL);

  if (cm_document.filename != NULL) {
//    gchar *pbufutf;
//    pbufutf = cm_filename_to_utf8(cm_document.filename);
//    if (pbufutf) {
//      gtk_file_selection_set_filename(GTK_FILE_SELECTION(fo.open_dlg), pbufutf);
//      g_free(pbufutf);
//    }
//    else {
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(fo.open_dlg),
                                      cm_document.filename);
//    }
  }

  /* ᥤ󥦥ɥθ˱Ƥޤʤ褦 */
  gtk_window_set_transient_for(GTK_WINDOW(fo.open_dlg), GTK_WINDOW(cm_window));

  /* ᥤ󥦥ɥ֤ */
  gdk_window_get_position(cm_window->window, &x, &y);
  gdk_window_get_size(cm_window->window, &width, &height);
  gtk_widget_realize(fo.open_dlg);
  gdk_window_get_size(fo.open_dlg->window, &dlg_width, &dlg_height);
  dlg_pos_x = x + (width - dlg_width) / 2;
  dlg_pos_y = y + (height - dlg_height) / 2;
  gtk_widget_set_uposition(fo.open_dlg,
                           (dlg_pos_x > 0) ? dlg_pos_x : 0,
                           (dlg_pos_y > 0) ? dlg_pos_y : 0);

  gtk_widget_show(fo.open_dlg);

  gtk_grab_add(fo.open_dlg);

  gtk_main();

  /*gtk_grab_remove(fo.open_dlg);*/

  return;
}

/****************************
   Save as ɽ
 ****************************/
void save_as_text(GtkWidget *widget, gpointer cur_doc)
{
  int x;
  int y;
  int width;
  int height;
  int dlg_width;
  int dlg_height;
  int dlg_pos_x;
  int dlg_pos_y;


  fo.open_dlg = gtk_file_selection_new("Save file as...");

  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(fo.open_dlg));

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->ok_button),
                     "clicked",
                     GTK_SIGNAL_FUNC(ok_cb_save),
                     cur_doc);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->cancel_button),
                     "clicked",
                     GTK_SIGNAL_FUNC(cancel_cb),
                     NULL);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)),
                     "destroy",
                     GTK_SIGNAL_FUNC(destroy_cb),
                     NULL);

  if (cm_document.filename != NULL) {
//    gchar *pbufutf;
//    pbufutf = cm_filename_to_utf8(cm_document.filename);
//    if (pbufutf) {
//      gtk_file_selection_set_filename(GTK_FILE_SELECTION(fo.open_dlg), pbufutf);
//      g_free(pbufutf);
//    }
//    else {
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(fo.open_dlg),
                                      cm_document.filename);
//    }
  }

  /* ᥤ󥦥ɥθ˱Ƥޤʤ褦 */
  gtk_window_set_transient_for(GTK_WINDOW(fo.open_dlg), GTK_WINDOW(cm_window));

  /* ᥤ󥦥ɥ֤ */
  gdk_window_get_position(cm_window->window, &x, &y);
  gdk_window_get_size(cm_window->window, &width, &height);
  gtk_widget_realize(fo.open_dlg);
  gdk_window_get_size(fo.open_dlg->window, &dlg_width, &dlg_height);
  dlg_pos_x = x + (width - dlg_width) / 2;
  dlg_pos_y = y + (height - dlg_height) / 2;
  gtk_widget_set_uposition(fo.open_dlg,
                           (dlg_pos_x > 0) ? dlg_pos_x : 0,
                           (dlg_pos_y > 0) ? dlg_pos_y : 0);

  gtk_widget_show(fo.open_dlg);

  gtk_grab_add(fo.open_dlg);

  gtk_main();

  /*gtk_grab_remove(fo.open_dlg);*/

  return;
}

/************************************************
   Хʥե16ʥפɽؿ
 ************************************************/
static void open_hex(gpointer textview, unsigned char *fname)
{
  FILE *input_fp;
  unsigned char *buf;
  struct stat stbuf;
  unsigned int size;
  unsigned int line_num;
  unsigned int i;
  unsigned char line_text[1024];
  unsigned char ascii_text[1024];
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  GtkTextIter ins_iter;
  gchar *pbufutf;


  mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          cm_msg_please_wait);

  i = warning(cm_msg_binary_warning);
  if (i == 1) {
    mlwrite(ML_BOTH,
            ML_IMMEDIATELY,
            cm_msg_file_not_opened_s,
            fname);
    return;
  }

  memset(&line_text[0], 0, 1024);
  memset(&ascii_text[0], 0, 1024);
  ascii_text[0] = ' ';

  /*freadΤ˳"rb"(Хʥ)ǳ*/
  if ((input_fp = fopen(fname, "rb")) != NULL) {
    /* GtkTextBuffer */
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));

    /* ƥȾõ */
    gtk_text_buffer_get_start_iter(buffer, &start_iter);
    gtk_text_buffer_get_end_iter(buffer, &end_iter);
    gtk_text_buffer_delete(buffer, &start_iter, &end_iter);

    /* bufferƬiterator */
    gtk_text_buffer_get_iter_at_offset(buffer, &ins_iter, 0);

    stat(fname, &stbuf);
    size = stbuf.st_size;

    /*ե륵ʬ*/
    buf = (unsigned char *)g_malloc(size);

    if (buf != NULL) {
      memset(buf, 0, size);
      /*ХʥեȤƽ뤿ե륵Ԥäɤ߹*/
      /*fread(buf, sizeof(char), size, input_fp);*/
      fread(buf, 1, size, input_fp);
      line_num = 0;
      for (i = 0; i < size; i++) {
        if ((i % 16) == 0) {
          sprintf(&line_text[strlen(line_text)], "%08x : ", line_num);
          line_num = line_num + 16;
        }

        sprintf(&line_text[strlen(line_text)], "%02x ", buf[i]);

        if (((int)buf[i] >= 0x20) && ((int)buf[i] <= 0x7e)) {
          ascii_text[(i % 16) + 1] = buf[i];
        }
        else {
          ascii_text[(i % 16) + 1] = '.';
        }

        if ((i % 16) == 7) {
          sprintf(&line_text[strlen(line_text)], "- ");
        }
        else if ((i % 16) == 15) {
          sprintf(&line_text[strlen(line_text)], "%s", &ascii_text[0]);
          sprintf(&line_text[strlen(line_text)], "\n");
          gtk_text_buffer_insert(buffer,
                                 &ins_iter,
                                 &line_text[0],
                                 strlen(&line_text[0]));
          memset(&line_text[0], 0, 1024);
          memset(&ascii_text[0], 0, 1024);
          ascii_text[0] = ' ';
        }
      }
      if ((strlen(line_text) < BIN_FORMAT) && (strlen(line_text) != 0)) {
        memset(&line_text[strlen(line_text)], 0x20, BIN_FORMAT - strlen(line_text));
        sprintf(&line_text[strlen(line_text)], "%s", &ascii_text[0]);
        sprintf(&line_text[strlen(line_text)], "\n");
        gtk_text_buffer_insert(buffer,
                               &ins_iter,
                               &line_text[0],
                               strlen(&line_text[0]));
      }
      g_free(buf);
    }
    fclose(input_fp);
    pbufutf = cm_filename_to_utf8(fname);
    if (pbufutf) {
      mlwrite(ML_BOTH, ML_IMMEDIATELY, cm_msg_file_opened_s, pbufutf);
      gtk_window_set_title(GTK_WINDOW(cm_window), pbufutf);
      g_free(pbufutf);
    }
    else {
      mlwrite(ML_BOTH,
              ML_IMMEDIATELY,
              cm_msg_file_opened_s,
              fname);
      gtk_window_set_title(GTK_WINDOW(cm_window), fname);
    }
    cm_document.filename = fo.filename;
    strcpy(cm_document.filename, fname);
    cm_document.modified = FALSE;
  }
  else {
    pbufutf = cm_filename_to_utf8(fname);
    if (pbufutf) {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_file_open_error_s, pbufutf);
      g_free(pbufutf);
    }
    else {
      mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_file_open_error_s, fname);
    }
  }

  return;
} /* ޥåʥСФΤɤʤؿ... */

/*******************
   cmemoư
 *******************/
void new_window(GtkWidget *widget, gpointer data)
{
  system("cmemo &");
}
