/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * Ƽ殺Хѿؿ
 */

/*
 * Cmemo : Text Editor
 * initial.c - source file for initialization
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "linenum.h"
#include "search.h"
#include "ini_file.h"
#include "kanji_conv.h"
#include "initial.h"
#include "keys.h"

#if SUPPORT_GETTEXT
#include <locale.h>
#include <libintl.h>
#define _(String) gettext(String)
#define N_(String) (String)
#else
#define _(String) (String)
#define N_(String) (String)
#endif

/* local declarations */
static void init_ftype_info(void);
static void init_kmode_info(void);
static void init_messages(void);

/* global variables */
char *cm_msg_exit_warning;
char *cm_msg_newtext_warning;
char *cm_msg_overwrite_warning;
char *cm_msg_binary_file_warning;
char *cm_msg_dropfile_received_s;
char *cm_msg_started_pid_u;
char *cm_msg_shared_memory_id_d;
char *cm_msg_illegal_option_s;
char *cm_msg_print_not_supported;
char *cm_msg_mode_changed_s;
char *cm_msg_return_code_lf;
char *cm_msg_return_code_cr;
char *cm_msg_return_code_crlf;
char *cm_msg_ignore_case;
char *cm_msg_dont_ignore_case;
char *cm_msg_mode_message_s1_s2_s3_s4;
char *cm_msg_display_refreshed_d;
char *cm_msg_changed_kanji_code_s;
char *cm_msg_changed_return_code_s;
char *cm_msg_file_not_found_s;
char *cm_msg_file_already_opened_s;
char *cm_msg_memory_full;
char *cm_msg_file_opened_s;
char *cm_msg_file_empty_s;
char *cm_msg_file_open_error_s;
char *cm_msg_file_wrote_s;
char *cm_msg_file_save_error_s;
char *cm_msg_file_not_opened_s;
char *cm_msg_file_cant_access_s;
char *cm_msg_directory_cant_open_s;
char *cm_msg_gsearch_canceled;
char *cm_msg_file_name_too_long_s1_s2;
char *cm_msg_search_directry_s ;
char *cm_msg_search_file_type_s;
char *cm_msg_search_word_s;
char *cm_msg_get_env_value_error_s;
char *cm_msg_too_long_home_dir_name;
char *cm_msg_too_long_dot_cmemo_name;
char *cm_msg_too_long_dot_cmemodb_name;
char *cm_msg_cant_find_dot_cmemo;
char *cm_msg_menu_new_window;
char *cm_msg_menu_open;
char *cm_msg_menu_save;
char *cm_msg_menu_save_as;
char *cm_msg_menu_print;
char *cm_msg_menu_exit;
char *cm_msg_menu_file;
char *cm_msg_menu_undo;
char *cm_msg_menu_redo;
char *cm_msg_menu_copy;
char *cm_msg_menu_cut;
char *cm_msg_menu_paste;
char *cm_msg_menu_select_all;
char *cm_msg_menu_edit;
char *cm_msg_menu_find;
char *cm_msg_menu_find_dlg_open;
char *cm_msg_menu_search_dn;
char *cm_msg_menu_search_up;
char *cm_msg_menu_replace;
char *cm_msg_menu_ignore_case;
char *cm_msg_menu_regex_search;
char *cm_msg_menu_jump_to;
char *cm_msg_menu_tag_jump;
char *cm_msg_menu_global_search;
char *cm_msg_menu_search;
char *cm_msg_menu_toolbar_visible;
char *cm_msg_menu_line_wrap;
char *cm_msg_menu_line_numbers;
char *cm_msg_menu_syntax_highlighting;
char *cm_msg_menu_refresh_display;
char *cm_msg_menu_view;
char *cm_msg_menu_play_key_macro;
char *cm_msg_menu_record_key_macro;
char *cm_msg_menu_cmds;
char *cm_msg_menu_lang;
char *cm_msg_show_mode;
char *cm_msg_mode;
char *cm_msg_settings;
char *cm_msg_version_info;
char *cm_msg_help;
char *cm_msg_input_jump_number;
char *cm_msg_jumped_s;
char *cm_msg_input_word_to_search;
char *cm_msg_input_word_to_replace;
char *cm_msg_count_replaced_d;
char *cm_msg_fail_to_malloc;
char *cm_msg_matched_line_column_d1_d2;
char *cm_msg_not_matched_current_line_d;
char *cm_msg_binary_warning;
char *cm_msg_file_size_warning;
char *cm_msg_fail_to_open_cmemodb;
char *cm_msg_cant_jump_to_s;
char *cm_msg_no_changes_need_to_be_saved;
char *cm_msg_wait;
char *cm_msg_please_wait;
char *cm_msg_mode_status_d1_d2_d3_d4;
char *cm_msg_line_column_d1_d2;
char *cm_msg_no_further_undo_info;
char *cm_msg_no_further_rndo_info;


/************************************************
   ftype_info¤ΤΥǡ(ǥե)
 ************************************************/
static void init_ftype_info(void)
{
  int i = 0;

  memset(cm_ft_inf, 0, sizeof(cm_ft_inf));

  /************************************************************
   ƥȥեʤ̾Υץ졼ƥȤФ
   ޤΥե뤫ȽǤʤäˤ⤳꤬Ȥ
   ************************************************************/
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].enabled = 1;
  strcpy(cm_ft_inf[i].title, "Plain");
  strcpy(cm_ft_inf[i].mode, "text-mode");
  strcpy(cm_ft_inf[i].ext, ".txt;.ini;.inf;.back");
  cm_ft_inf[i].acckey = 'T';
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[i].ignore_case = 0;
  strcpy(cm_ft_inf[i].key1buf, "http;ftp;mail");
  strcpy(cm_ft_inf[i].key2buf, "tel;no;room");
//  strcpy(cm_ft_inf[i].cmt_start, "/*");
//  strcpy(cm_ft_inf[i].cmt_end, "*/");
  strcpy(cm_ft_inf[i].line_cmt, "#");
  cm_ft_inf[i].str_start = '\"';
  cm_ft_inf[i].str_end = '\"';
//  cm_ft_inf[i].chr_start = '\'';
//  cm_ft_inf[i].chr_end = '\'';
  cm_ft_inf[i].esc_chr = '\\';
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));
  cm_ft_inf[i].line_wrap = 1;
  i++;

  /***********
   Cץ
   ***********/
  /* ֹΥǡͭǤ뤫ɤɽե饰 */
  /* ץκǽ餫롼פʤ餳Υե饰 */
  /* å0ǤLang˥塼˲äʤ    */
  /* եˤϹԤʤΤǥ桼ռ */
  /* ɬפ̵͡                                       */
  cm_ft_inf[i].data_flag = 1;

  /* ˥塼ͭˤ뤫ɤΥե饰 */
  cm_ft_inf[i].enabled = 1;

  /* ˥塼ɽʸ */
  strcpy(cm_ft_inf[i].title, "C");

  /* ߥ˥Хåեɽ⡼ɤ̾ */
  strcpy(cm_ft_inf[i].mode, "c-mode");

  /* Υ⡼ɤΥ롼פ˴ޤޤեγĥ     */
  /* ʣꤹ϶򳫤˥ߥǶڤ */
  /*  ".txt;.ini;.inf;.log"                           */
  strcpy(cm_ft_inf[i].ext, ".c");

  /* Shift+Alt+(key)ǳƤ륢졼  */
  cm_ft_inf[i].acckey = 'C';

  /* ȡ˶ڤݤʸν */
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");

  /* ɤʸʸ̤뤫ɤΥե饰 */
  cm_ft_inf[i].ignore_case = 0;

  /* ɣǤ2048Х̤ǻꤹ   */
  /* ʣꤹ϶򳫤˥ߥǶڤ */
  strcpy(cm_ft_inf[i].key1buf,
         "if;else;switch;case;default;break;for;while;do;continue;goto;"
         "sizeof;char;double;int;long;enum;float;short;unsigned;signed;void");

  /* ɣǤ2048Х̤ǻꤹ   */
  /* ʣꤹ϶򳫤˥ߥǶڤ */
  strcpy(cm_ft_inf[i].key2buf,
         "#include;#define;#if;#ifdef;#endif;#else;#ifndef;#undef;typedef;"
         "auto;register;extern;static;volatile;union;struct;const;return");

  /* ȳʸ */
  strcpy(cm_ft_inf[i].cmt_start, "/*");

  /* Ƚλʸ */
  strcpy(cm_ft_inf[i].cmt_end, "*/");

  /* ԥʸ */
  strcpy(cm_ft_inf[i].line_cmt, "");

  /* ʸ󳫻ʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[i].str_start = '\"';

  /* ʸλʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[i].str_end = '\"';

  /* ʸʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[i].chr_start = '\'';

  /* ʸλʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[i].chr_end = '\'';

  /* ʸ˻Ѥʸ */
  cm_ft_inf[i].esc_chr = '\\';

  /* Ƽ參顼 */
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));

  /* μΥե򳫤˱üǼưޤ֤򤹤뤫ɤ */
  cm_ft_inf[i].line_wrap = 0;
  i++;

  /*************
   C++ץ
   *************/
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].enabled = 1;
  strcpy(cm_ft_inf[i].title, "C++");
  strcpy(cm_ft_inf[i].mode, "cpp-mode");
  strcpy(cm_ft_inf[i].ext, ".cpp;.cxx;.C;.cc;.h");
  cm_ft_inf[i].acckey = 'O';
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[i].ignore_case = 0;
  strcpy(cm_ft_inf[i].key1buf,
         "if;else;switch;case;default;break;for;while;do;continue;goto;"
         "sizeof;char;double;int;long;enum;float;short;unsigned;signed;void");
  strcpy(cm_ft_inf[i].key2buf,
         "#include;#define;#if;#ifdef;#endif;#else;#ifndef;#undef;typedef;"
         "auto;register;extern;static;volatile;union;struct;const;class;"
         "private;public;return");
  strcpy(cm_ft_inf[i].cmt_start, "/*");
  strcpy(cm_ft_inf[i].cmt_end, "*/");
  strcpy(cm_ft_inf[i].line_cmt, "//");
  cm_ft_inf[i].str_start = '\"';
  cm_ft_inf[i].str_end = '\"';
  cm_ft_inf[i].chr_start = '\'';
  cm_ft_inf[i].chr_end = '\'';
  cm_ft_inf[i].esc_chr = '\\';
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));
  cm_ft_inf[i].line_wrap = 0;
  i++;

  /**************************
   Htmlɥ
   ɤʬʤΤŬǤ
   **************************/
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].enabled = 1;
  strcpy(cm_ft_inf[i].title, "Html");
  strcpy(cm_ft_inf[i].mode, "html-mode");
  strcpy(cm_ft_inf[i].ext, ".html;.htm");
  cm_ft_inf[i].acckey = 'H';
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[i].ignore_case = 1;

  /* Thanks to MATSUMURA Tomohiro for Html keywords */
  strcpy(cm_ft_inf[i].key1buf,
         "HTML;HEAD;TITLE;P;BR;UL;DL;TD;TR;HR;A;H;PRE");
  strcpy(cm_ft_inf[i].key2buf,
         "BODY;LINK;IMG;SRC;ALT;WIDTH;HEIGHT;HREF;LI;DT;DD;BORDER;ID;NAME");

  strcpy(cm_ft_inf[i].cmt_start, "<!--");
  strcpy(cm_ft_inf[i].cmt_end, "-->");
  strcpy(cm_ft_inf[i].line_cmt, "");
  cm_ft_inf[i].str_start = '\"';
  cm_ft_inf[i].str_end = '\"';
  cm_ft_inf[i].chr_start = '\0';
  cm_ft_inf[i].chr_end = '\0';
  cm_ft_inf[i].esc_chr = '\\';
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));
  cm_ft_inf[i].line_wrap = 1;
  i++;

  /**************
   Javaץ
   **************/
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].enabled = 1;
  strcpy(cm_ft_inf[i].title, "Java");
  strcpy(cm_ft_inf[i].mode, "java-mode");
  strcpy(cm_ft_inf[i].ext, ".java");
  cm_ft_inf[i].acckey = 'J';
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[i].ignore_case = 0;
  strcpy(cm_ft_inf[i].key1buf,
         "boolean;break;byte;case;catch;char;continue;default;do;double;"
         "else;finally;float;for;goto;if;int;long;new;short;switch;this;"
         "throw;throws;try;void;while");
  strcpy(cm_ft_inf[i].key2buf,
         "abstract;class;const;extends;final;implements;import;instanceof;"
         "interface;native;package;private;protected;public;return;static;"
         "strictfp;super;synchronized;transient;volatile;widefp;true;false;"
         "null");
  strcpy(cm_ft_inf[i].cmt_start, "/*");
  strcpy(cm_ft_inf[i].cmt_end, "*/");
  strcpy(cm_ft_inf[i].line_cmt, "//");
  cm_ft_inf[i].str_start = '\"';
  cm_ft_inf[i].str_end = '\"';
  cm_ft_inf[i].chr_start = '\'';
  cm_ft_inf[i].chr_end = '\'';
  cm_ft_inf[i].esc_chr = '\\';
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));
  cm_ft_inf[i].line_wrap = 0;
  i++;

  /****************
   Pascalץ
   ****************/
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].enabled = 1;
  strcpy(cm_ft_inf[i].title, "Pascal");
  strcpy(cm_ft_inf[i].mode, "pascal-mode");
  strcpy(cm_ft_inf[i].ext, ".pas;.dpr;.dpk;.inc");
  cm_ft_inf[i].acckey = 'P';
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[i].ignore_case = 1;
  strcpy(cm_ft_inf[i].key1buf,
         "and;as;case;div;do;downto;else;for;goto;if;in;is;mod;not;of;"
         "or;out;packed;then;to;while;try;finally;except;finalization;"
         "with;xor;until;file;nil;string;object;label;library;"
         "resourcestring;integer;read;write;char;begin;end;interface;"
         "implementation;threadvar;var");
  strcpy(cm_ft_inf[i].key2buf,
         "class;const;dynamic;dispid;safecall;stdcall;overload;override;"
         "stored;property;program;initialization;inherited;inline;function;"
         "dispinterface;constructor;destructor;private;public;protected;"
         "published;virtual;automated;procedure;unit;far;forward;implements;"
         "exports;export;external;type;uses;absolute;abstract;assembler;at;"
         "automated;cdecl;contains;default;index;message;name;near;shl;shr;"
         "nodefaul;package;pascal;readonly;writeonly;repeat;raise;register;"
         "requires;resident;reintroduce;record;set;array;asm");
  strcpy(cm_ft_inf[i].cmt_start, "{");
  strcpy(cm_ft_inf[i].cmt_end, "}");
  strcpy(cm_ft_inf[i].line_cmt, "//");
  cm_ft_inf[i].str_start = '\'';
  cm_ft_inf[i].str_end = '\'';
  cm_ft_inf[i].chr_start = '\'';
  cm_ft_inf[i].chr_end = '\'';
  cm_ft_inf[i].esc_chr = '#';
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));
  cm_ft_inf[i].line_wrap = 0;
  i++;

  /********************************
   Tcl/Tkץ
   TkޥɤϤޤäƤޤ
   ********************************/
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].enabled = 1;
  strcpy(cm_ft_inf[i].title, "Tcl/Tk");
  strcpy(cm_ft_inf[i].mode, "tcltk-mode");
  strcpy(cm_ft_inf[i].ext, ".tcl;.tk;.TCL;.TK");
  cm_ft_inf[i].acckey = 'L';
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[i].ignore_case = 0;
  strcpy(cm_ft_inf[i].key1buf,
         "set;unset;incr;append;expr;array;exists;size;get;names;startsearch;"
         "nextelement;donesearch;split;join;string;compare;index;range;first;"
         "last;wordstart;wordend;match;tolower;toupper;trimleft;trimright;trim;"
         "format;scan;regexp;regsub;llength;lindex;concat;list;lappend;linsert;"
         "lrange;lreplace;lsearch;open;close;gets;read;puts;flush;tell;seek;"
         "fblocked;fconfigure;socket;file;atime;mtime;exists;executable;owned;"
         "readable;writable;isfile;isdirectory;type;readlink;dirname;tail;"
         "extension;stat;lstat;glob;pwd;cd;if;for;foreach;while;break;continue;"
         "switch;catch;exec;edit;search;help;toplevel");
  strcpy(cm_ft_inf[i].key2buf,
         "proc;return;code;errorinfo;errorcode;global;upvar;uplevel;exit;rename;"
         "pid;time;clock;clicks;seconds;format;scan;info;args;body;cmdcount;"
         "commands;eval;subst;source;interp;create;delete;exists;issafe;slaves;"
         "eval;alias;target;aliases;share;transfer;auto_execok;auto_load;"
         "auto_mkindex;auto_reset;parray;package;require;ifneeded;unknown;"
         "provide;forget;names;versions;vcompare;vsatisfies;load;pkg_mkIndex;"
         "wish");
  strcpy(cm_ft_inf[i].cmt_start, "\0");
  strcpy(cm_ft_inf[i].cmt_end, "\0");
  strcpy(cm_ft_inf[i].line_cmt, "#");
  cm_ft_inf[i].str_start = '\"';
  cm_ft_inf[i].str_end = '\"';
  cm_ft_inf[i].chr_start = '\0';
  cm_ft_inf[i].chr_end = '\0';
  cm_ft_inf[i].esc_chr = '\\';
  memcpy(cm_ft_inf[i].basic_color, cm_basic_color, sizeof(cm_basic_color));
  memcpy(cm_ft_inf[i].keyword1_color, cm_keyword1_color, sizeof(cm_keyword1_color));
  memcpy(cm_ft_inf[i].keyword2_color, cm_keyword2_color, sizeof(cm_keyword2_color));
  memcpy(cm_ft_inf[i].number_color, cm_number_color, sizeof(cm_number_color));
  memcpy(cm_ft_inf[i].comment_color, cm_comment_color, sizeof(cm_comment_color));
  memcpy(cm_ft_inf[i].string_color, cm_string_color, sizeof(cm_string_color));
  cm_ft_inf[i].line_wrap = 0;
  i++;

  return;
}

/********************************
   kmode_info¤ΤΥǡ
 ********************************/
static void init_kmode_info(void)
{
  int i;

  i = 0;
  memset(cm_km_inf, 0, sizeof(cm_km_inf));

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = ASCII; /* 5 */
  strcpy(cm_km_inf[i].title, "ASCII");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = EUC_JP; /* 0 */
  strcpy(cm_km_inf[i].title, "EUC-JP");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = SHIFT_JIS; /* 1 */
  strcpy(cm_km_inf[i].title, "S-JIS");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = JIS2022; /* 2 */
  strcpy(cm_km_inf[i].title, "JIS2022");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = UTF_8; /* 3 */
  strcpy(cm_km_inf[i].title, "UTF-8");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 0;
  cm_km_inf[i].mode_id = BINARY; /* 4 */
//  strcpy(cm_km_inf[i].title, "BINARY(\?\?\?)");
  strcpy(cm_km_inf[i].title, "BINARY");
  i++;

  return;
}

/**************************
   Ƽåν
 **************************/
static void init_messages()
{
#if SUPPORT_GETTEXT
  setlocale(LC_ALL, "");
  bindtextdomain(PACKAGE, LOCALEDIR);
  bind_textdomain_codeset(PACKAGE, "UTF-8");
  textdomain(PACKAGE);
#endif

  cm_msg_exit_warning = _(" Modified buffers exist.\nDo you exit anyway?");
  cm_msg_newtext_warning = _(" Modified buffers exist.\nDo you open a new text?");
  cm_msg_overwrite_warning = _(" The file already exists.\nAre you ok to overwrite?");
  cm_msg_binary_file_warning = _("SORRY! THIS MIGHT BE A BINARY FILE. CMEMO CAN NOT SAVE BINARY FILES.");
  cm_msg_dropfile_received_s = _("Received \"%s\"");
  cm_msg_started_pid_u = _("cmemo started [pid = %u]");
  cm_msg_shared_memory_id_d = _("shared_memory_id : %d");
  cm_msg_illegal_option_s = _("illegal option (%s)");
  cm_msg_print_not_supported = _("SORRY! \"PRINT\" IS NOT SUPPORTED!");
  cm_msg_mode_changed_s = _("changed : %s");
  cm_msg_return_code_lf = _("LF");
  cm_msg_return_code_cr = _("CR");
  cm_msg_return_code_crlf = _("CRLF");
  cm_msg_ignore_case = _("IGNORE CASE");
  cm_msg_dont_ignore_case = _("DON\'T IGNORE CASE");
  cm_msg_mode_message_s1_s2_s3_s4 = _("MODE : %s : %s : %s : %s");
  cm_msg_display_refreshed_d = _("refreshed (current line %d)");
  cm_msg_changed_kanji_code_s = _("Changed Kanji Code : %s");
  cm_msg_changed_return_code_s = _("Changed Return Code : %s");
  cm_msg_file_not_found_s = _("file not found: %s");
  cm_msg_file_already_opened_s = _("the file \"%s\" is already opened");
  cm_msg_memory_full = _("Memory Full");
  cm_msg_file_opened_s = _("Opened: %s");
  cm_msg_file_empty_s = _("empty file: %s");
  cm_msg_file_open_error_s = _("Open Error: %s");
  cm_msg_file_wrote_s = _("Wrote %s");
  cm_msg_file_save_error_s = _("Save failed %s");
  cm_msg_file_not_opened_s = _("not opened: %s");
  cm_msg_file_cant_access_s = _("isfile: can't access %s\n");
  cm_msg_directory_cant_open_s = _("dirwalk: can't open %s\n");
  cm_msg_gsearch_canceled = _("Global Search Canceled!");
  cm_msg_file_name_too_long_s1_s2 = _("file name \"%s%s\" too long\n");
  cm_msg_search_directry_s  = _("  search directry  : %s\n");
  cm_msg_search_file_type_s = _("  search file type : %s\n");
  cm_msg_search_word_s      = _("  search word      : %s\n");
  cm_msg_get_env_value_error_s = _("fail to get environment value. (%s)");
  cm_msg_too_long_home_dir_name = _("too long home directory name");
  cm_msg_too_long_dot_cmemo_name = _("too long ~/.cmemo name");
  cm_msg_too_long_dot_cmemodb_name = _("too long ~/.cmemodb name");
  cm_msg_cant_find_dot_cmemo = _("can\'t find ~/.cmemo");
  cm_msg_menu_new_window = _("New Window");
  cm_msg_menu_open = _("Open");
  cm_msg_menu_save = _("Save");
  cm_msg_menu_save_as = _("Save as");
  cm_msg_menu_print = _("Print...");
  cm_msg_menu_exit = _("Exit");
  cm_msg_menu_file = _("_File");
  cm_msg_menu_undo = _("Undo");
  cm_msg_menu_redo = _("Redo");
  cm_msg_menu_copy = _("Copy");
  cm_msg_menu_cut = _("Cut");
  cm_msg_menu_paste = _("Paste");
  cm_msg_menu_select_all = _("Select All");
  cm_msg_menu_edit = _("_Edit");
  cm_msg_menu_find = _("Find...");
  cm_msg_menu_find_dlg_open = _("Find Dlg Open");
  cm_msg_menu_search_dn = _("Search Dn");
  cm_msg_menu_search_up = _("Search Up");
  cm_msg_menu_replace = _("Replace...");
  cm_msg_menu_ignore_case = _("Ignore Case ?");
  cm_msg_menu_regex_search = _("Use Regex ?");
  cm_msg_menu_jump_to = _("Jump to...");
  cm_msg_menu_tag_jump = _("Tag Jump");
  cm_msg_menu_global_search = _("Global Search");
  cm_msg_menu_search = _("_Search");
  cm_msg_menu_toolbar_visible = _("Toolbar Visible");
  cm_msg_menu_line_wrap = _("Line Wrap");
  cm_msg_menu_line_numbers = _("Line Numbers");
  cm_msg_menu_syntax_highlighting = _("Syntax Highlighting");
  cm_msg_menu_refresh_display = _("Refresh Display");
  cm_msg_menu_view = _("_View");
  cm_msg_menu_play_key_macro = _("Play Key Macro");
  cm_msg_menu_record_key_macro = _("Record Key Macro");
  cm_msg_menu_cmds = _("_Cmds");
  cm_msg_menu_lang = _("_Lang");
  cm_msg_show_mode = _("Show Mode");
  cm_msg_mode = _("_Mode");
  cm_msg_settings = _("Settings...");
  cm_msg_version_info = _("Version Info");
  cm_msg_help = _("_Help");
  cm_msg_input_jump_number = _("Input Number to Jump!!");
  cm_msg_jumped_s = _("Jumped : %s");
  cm_msg_input_word_to_search = _("Input Word to Search!!");
  cm_msg_input_word_to_replace = _("Replace word is blank!!");
  cm_msg_count_replaced_d = _("%d replaced");
  cm_msg_fail_to_malloc = _("fail to malloc...");
  cm_msg_matched_line_column_d1_d2 = _("matched in line %d column %d");
  cm_msg_not_matched_current_line_d = _("not matched (current line %d)");
  cm_msg_binary_warning = _(" This might be a binary file.\n"
                          "Cmemo can\'t edit binary files.\n"
                          "Do you open anyway?");
  cm_msg_file_size_warning = _(" The size of this file is too big.\n"
                             "Cmemo takes for a few minutes to do synthax hilighting.\n"
                             "Do you want Cmemo to analyze synthax?");
  cm_msg_fail_to_open_cmemodb = _("fail to open ~/.cmemodb");
  cm_msg_cant_jump_to_s = _("Can\'t Jump to %s!!");
  cm_msg_no_changes_need_to_be_saved = _("(No changes need to be saved)");
  cm_msg_wait = _("Wait...");
  cm_msg_please_wait = _("PLEASE WAIT...");
  cm_msg_mode_status_d1_d2_d3_d4 = _("STATUS : {%d} (%d) L%d-C%d");
  cm_msg_line_column_d1_d2 = _("L%d-C%d");
  cm_msg_no_further_undo_info = _("No further undo information.");
  cm_msg_no_further_rndo_info = _("No further redo information.");
}

/********************************
   Ƽե饰ؿ
 ********************************/
int init_flags(void)
{
  cm_end_flag = 0;
  cm_all_lines = 1;
  cm_input_mode = 0;
  /*cm_kanji_mode = EUC_JP;*/
  cm_kanji_mode = ASCII;
  cm_return_mode = CME_LF;

  /* ưǥȤͭˤ뤫ɤɽ(0:̵ 1:ͭ) */
  cm_indent_mode = 0;

  /* κݤʸʸ̵뤹뤫ɤɽ(0: 1:̵) */
  cm_ignore_case = 0;

  /* եȥեߥ꡼() */
  strcpy(cm_key_font, "fixed");

  /* եȥեߥ꡼(ƥ) */
  strcpy(cm_text_font, "fixed");

  /* ɥեȤ */
  cm_key_weight = PANGO_WEIGHT_NORMAL;

  /* ƥȥեȤ */
  cm_text_weight = PANGO_WEIGHT_NORMAL;

  /* եȥ */
  cm_font_size = 12;

  /* ١顼(֥å) */
  strcpy(cm_basic_color, "black");

  /* ɥ顼(꡼) */
  strcpy(cm_keyword1_color, "green4");

  /* ɥ顼(֥롼) */
  strcpy(cm_keyword2_color, "blue");

  /* ͥ顼(å) */
  strcpy(cm_number_color, "red");

  /* ȥ顼(졼51) */
  strcpy(cm_comment_color, "grey51");

  /* ʸ󥫥顼(ѡץ3) */
  strcpy(cm_string_color, "purple3");

  /* ֹطʿ */
  strcpy(cm_line_bg_color, "white");

  /* ֹʿ */
  strcpy(cm_line_fg_color, "black");

  /* ȥ륳ʿ(졼51) */
  strcpy(cm_ctrl_color, "grey51");

  /* ƥΰطʿ */
  strcpy(cm_text_bg_color, "white");

  /* ġСɽ */
  cm_toolbar_visible = 0;

  /* ޤ֤ */
  cm_line_wrap = 0;

  /* ֹɽ */
  cm_line_number = 0;

  /* ʸĴɽ */
  cm_syn_highlight = 1;

  /* ɸϤ뤫ɤ */
  cm_console_out = 0;

  /* EmacsХ */
  cm_emacs_key = 0;

  init_ftype_info();
  init_kmode_info();
  init_messages();
  init_key_macro_events();

  return(0);
}
