/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * Ӳΰ٤δؿ
 */

/*
 * Cmemo : Text Editor
 * search.c - source file for searching strings
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "cme_misc.h"
#include "bm_search.h"


#define SEARCH_UP 0
#define SEARCH_DN 1

int cm_ignore_case;
static int cm_found = 0;

static int replace_message(gchar *message, struct text_struct *doc);


/************
   岼
 ************/
/* 0:FALSE 1:TRUE  */
int search_up_dn(unsigned char *s_text, unsigned char *s_word,
                 long *count_from_start, long *num_of_char,
                 int up_dn_flag, int matchcase)
{
  int hit_pos;
  unsigned char *search_p;

  if (up_dn_flag == SEARCH_UP) {
    hit_pos = bm_re_search(s_text,
                           strlen(s_text),
                           s_word,
                           strlen(s_word),
                           matchcase);
  }
  else { /* SEARCH_DN */
    hit_pos = bm_search(s_text,
                        strlen(s_text),
                        s_word,
                        strlen(s_word),
                        matchcase);
  }

  /* ȯñؤΥݥ󥿤򥻥å */
  if (hit_pos == -1) {
    search_p = NULL;
  }
  else {
    search_p = s_text + hit_pos;
  }

  /* ȯ褿ɤˤäƽ򿶤ʬ */
  if (search_p == NULL) {
    return(0);
  }
  else {
    /*ȯ֤ޤǤʸ򥫥Ȥ*/
    *count_from_start = get_char_count(s_text, search_p - s_text);

    /*ñʸ򥫥Ȥ*/
    *num_of_char = get_char_count(s_word, strlen(s_word));

    /*ñȯ*/
    return(1);
  }
  return(0);
}

/*****************************************************************
   ʸʸΰ㤤̵뤹뤫ɤΥե饰ONޤOFF
 *****************************************************************/
int case_on_off(GtkWidget *widget, gpointer data)
{
  if (cm_ignore_case == 0) {
    cm_ignore_case = 1;
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_ignore_case);
  }
  else {
    cm_ignore_case = 0;
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_dont_ignore_case);
  }
  return(0);
}

/**************
   
 **************/
void up_search(GtkWidget *widget, gpointer cur_doc)
{
  int res;
  long count_s;
  long count_c;
  unsigned char *s_text;
  unsigned char *s_word;
  gint f_line;
  gint f_column;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  GtkTextIter mark_iter;


  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  count_s = 0;
  count_c = 0;
  gtk_widget_grab_focus(doc->textbox);

  s_word = gtk_editable_get_chars(GTK_EDITABLE(cm_search.entry), 0, -1);
  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_input_word_to_search);
    if (s_word) {
      g_free(s_word);
    }
    search_hide_cb(widget, cur_doc);
    return;
  }

  gtk_text_buffer_get_start_iter(buffer, &start_iter);
  gtk_text_buffer_get_iter_at_mark(buffer,
                                   &end_iter,
                                   gtk_text_buffer_get_mark(buffer, "insert"));
  s_text = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
  if (s_text == NULL) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_fail_to_malloc);
    search_hide_cb(widget, cur_doc);
    return;
  }
  res = search_up_dn(s_text, s_word, &count_s, &count_c, SEARCH_UP, cm_ignore_case);

  /*debug*/
  /*printf("result is %d\n", res);
  printf("Ƭ %d ʸ\n", count_s);
  printf("ʸ %d ʸ\n", count_c);*/

  /* ҥåȤ */
  if (res == 1) {
    /* ȯʸȿž */
    memcpy(&mark_iter, &start_iter, sizeof(GtkTextIter));
    gtk_text_iter_forward_chars(&start_iter, count_s);
    gtk_text_iter_forward_chars(&mark_iter, count_s + count_c);
    gtk_text_buffer_place_cursor(buffer, &start_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "selection_bound", &mark_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "insert", &start_iter);

    /* Է */
    f_line = gtk_text_iter_get_line(&mark_iter);
    f_column = gtk_text_iter_get_line_offset(&mark_iter);

    /*  */
    scrollbar_update(doc, f_line, &start_iter);

    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            cm_msg_matched_line_column_d1_d2,
            f_line + 1, f_column);
    set_cur_line_number(f_line);
  }
  else {
    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            cm_msg_not_matched_current_line_d,
            get_cur_line_number() + 1);
  }

  g_free(s_word);
  g_free(s_text);
  search_hide_cb(widget, cur_doc);
  return;
}

/**************
   
 **************/
void dn_search(GtkWidget *widget, gpointer cur_doc)
{
  int res;
  long count_s;
  long count_c;
  unsigned char *s_text;
  unsigned char *s_word;
  gint f_line;
  gint f_column;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  GtkTextIter mark_iter;


  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  count_s = 0;
  count_c = 0;
  gtk_widget_grab_focus(doc->textbox);

  s_word = gtk_editable_get_chars(GTK_EDITABLE(cm_search.entry), 0, -1);
  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_input_word_to_search);
    if (s_word) {
      g_free(s_word);
    }
    search_hide_cb(widget, cur_doc);
    cm_found = 0;
    return;
  }

  gtk_text_buffer_get_iter_at_mark(buffer,
                                   &start_iter,
                                   gtk_text_buffer_get_mark(buffer, "insert"));
  gtk_text_buffer_get_end_iter(buffer, &end_iter);
  s_text = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
  if (s_text == NULL) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_fail_to_malloc);
    search_hide_cb(widget, cur_doc);
    cm_found = 0;
    return;
  }
  res = search_up_dn(s_text, s_word, &count_s, &count_c, SEARCH_DN, cm_ignore_case);

  /*debug*/
  /*printf("result is %d\n", res);
  printf("Ƭ %d ʸ\n", count_s);
  printf("ʸ %d ʸ\n", count_c);*/

  /* ҥåȤ */
  if (res == 1) {
    /* ȯʸȿž */
    memcpy(&mark_iter, &start_iter, sizeof(GtkTextIter));
    gtk_text_iter_forward_chars(&mark_iter, count_s);
    gtk_text_iter_forward_chars(&start_iter, count_s + count_c);
    gtk_text_buffer_place_cursor(buffer, &start_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "selection_bound", &mark_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "insert", &start_iter);

    /* Է */
    f_line = gtk_text_iter_get_line(&mark_iter);
    f_column = gtk_text_iter_get_line_offset(&mark_iter);

    /*  */
    scrollbar_update(doc, f_line, &start_iter);

    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            cm_msg_matched_line_column_d1_d2,
            f_line + 1,
            f_column);
    set_cur_line_number(f_line);
    cm_found = 1;
  }
  else {
    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            cm_msg_not_matched_current_line_d,
            get_cur_line_number() + 1);
    cm_found = 0;
  }

  g_free(s_word);
  g_free(s_text);
  search_hide_cb(widget, cur_doc);
  return;
}

#define REPLACE_YES    0
#define REPLACE_NO     1
#define REPLACE_ALL    2
#define REPLACE_CALCEL 3

void replace_main(GtkWidget *widget, gpointer cur_doc)
{
  unsigned char *s_word;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
//  GtkTextIter end_iter;
  int ret;
  gint count;

  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));

  s_word = gtk_editable_get_chars(GTK_EDITABLE(cm_search.rep_entry), 0, -1);
/*  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_input_word_to_replace);
    if (s_word) {
      g_free(s_word);
    }
    search_hide_cb(widget, cur_doc);
    return;
  }*/

  count = 0;
  ret = REPLACE_CALCEL;
  while (dn_search(widget, cur_doc), cm_found == 1) {
    if (ret != REPLACE_ALL) {
      ret = replace_message("Replace?", doc);
    }
    if (ret == REPLACE_YES || ret == REPLACE_ALL) {
      /* öߤ */
      gtk_text_buffer_begin_user_action(buffer);
      gtk_text_buffer_delete_selection(buffer, TRUE,
                                       GTK_TEXT_VIEW(doc->textbox)->editable);
      gtk_text_buffer_get_iter_at_mark(buffer, &start_iter,
                                       gtk_text_buffer_get_insert(buffer));
      gtk_text_buffer_insert(buffer, &start_iter, s_word, strlen(s_word));
      count++;
      /* Ƴ */
      gtk_text_buffer_end_user_action(buffer);
    }
    else if (ret == REPLACE_CALCEL) {
      break;
    }
//    while (gtk_events_pending())
//      gtk_main_iteration();
  }
  mlwrite(ML_E_ONLY, ML_IMMEDIATELY, cm_msg_count_replaced_d, count);
}

struct replace_data {
  GtkWidget *dialog;
  int type;
};

static int replace_btn_ret = REPLACE_CALCEL;

static void replace_btn_cb(GtkWidget* button, gpointer data)
{
  struct replace_data *rep_data;

  rep_data = (struct replace_data *)data;
  replace_btn_ret = rep_data->type;
  gtk_widget_destroy(rep_data->dialog);
}

gint replace_dlg_key_cb(GtkWidget *widget, GdkEvent *event, gpointer dialog)
{
  GdkEventKey *kevent = (GdkEventKey *)event;
  struct replace_data rep_data;

  if (kevent->state == GDK_MOD1_MASK) {
    return(FALSE);
  }
  else {
    if (kevent->keyval == GDK_Y || kevent->keyval == GDK_y) {
      rep_data.dialog = dialog;
      rep_data.type = REPLACE_YES;
    }
    else if (kevent->keyval == GDK_N || kevent->keyval == GDK_n) {
      rep_data.dialog = dialog;
      rep_data.type = REPLACE_NO;
    }
    else if (kevent->keyval == GDK_A || kevent->keyval == GDK_a) {
      rep_data.dialog = dialog;
      rep_data.type = REPLACE_ALL;
    }
    else if (kevent->keyval == GDK_C || kevent->keyval == GDK_c) {
      rep_data.dialog = dialog;
      rep_data.type = REPLACE_CALCEL;
    }
    else if (kevent->keyval == GDK_Escape || kevent->keyval == GDK_Cancel) {
      rep_data.dialog = dialog;
      rep_data.type = REPLACE_CALCEL;
    }
    else {
      return(FALSE);
    }
    replace_btn_cb(NULL, &rep_data);
  }
  return(TRUE);
}

static int replace_message(gchar *message, struct text_struct *doc)
{
  struct replace_data yes_data, no_data, all_data, cancel_data;
  GtkWidget *dialog;
//  GtkWidget *label;
//  GtkWidget *w_vbox;
  GtkWidget *w_hbox;
  GtkWidget *yes_button, *no_button, *all_button, *cancel_button;
//  gint btn_w, btn_h;
//  GdkRectangle location;
//  GtkTextIter iter;
//  GtkTextBuffer *buffer;
//  gint x, y, left_size;
  gint wnd_x, wnd_y;
  gint wnd_width, wnd_height;
  gint dlg_width, dlg_height;
  gint dlg_pos_x, dlg_pos_y;

  dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);

//  w_vbox = gtk_vbox_new(FALSE, 0);
//  gtk_container_add(GTK_CONTAINER(dialog), w_vbox);
//  gtk_widget_show(w_vbox);

//  label = gtk_label_new (message);
//  gtk_widget_show(label);
//  gtk_box_pack_start(GTK_BOX(w_vbox), label, TRUE, TRUE, 0);

  w_hbox = gtk_hbox_new(FALSE, 0);
//  gtk_box_pack_start(GTK_BOX(w_vbox), w_hbox, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(dialog), w_hbox);
  gtk_widget_show(w_hbox);

  yes_button = gtk_button_new_with_mnemonic("_Yes");
  no_button =  gtk_button_new_with_mnemonic("_No");
  all_button =  gtk_button_new_with_mnemonic("_All");
  cancel_button =  gtk_button_new_with_mnemonic("_Cancel");

  gtk_widget_show(yes_button);
  gtk_widget_show(no_button);
  gtk_widget_show(all_button);
  gtk_widget_show(cancel_button);

  yes_data.dialog = dialog;
  yes_data.type = REPLACE_YES;
  no_data.dialog = dialog;
  no_data.type = REPLACE_NO;
  all_data.dialog = dialog;
  all_data.type = REPLACE_ALL;
  cancel_data.dialog = dialog;
  cancel_data.type = REPLACE_CALCEL;

  gtk_signal_connect(GTK_OBJECT(yes_button), "clicked",
                     GTK_SIGNAL_FUNC (replace_btn_cb), (gpointer)&yes_data);
  gtk_signal_connect(GTK_OBJECT(no_button), "clicked",
                     GTK_SIGNAL_FUNC (replace_btn_cb), (gpointer)&no_data);
  gtk_signal_connect(GTK_OBJECT(all_button), "clicked",
                     GTK_SIGNAL_FUNC (replace_btn_cb), (gpointer)&all_data);
  gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked",
                     GTK_SIGNAL_FUNC (replace_btn_cb), (gpointer)&cancel_data);
  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
                     GTK_SIGNAL_FUNC(gtk_main_quit), (gpointer)dialog);

//  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area), yes_button);
//  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area), no_button);
//  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area), all_button);
//  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area), cancel_button);
//  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), label);
  gtk_box_pack_start(GTK_BOX(w_hbox), yes_button, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(w_hbox), no_button, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(w_hbox), all_button, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(w_hbox), cancel_button, TRUE, TRUE, 0);

  gtk_widget_set_size_request(yes_button, 50, -1);
  gtk_widget_set_size_request(no_button, 50, -1);
  gtk_widget_set_size_request(all_button, 50, -1);
  gtk_widget_set_size_request(cancel_button, 50, -1);

  gtk_window_get_position(GTK_WINDOW(cm_window), &wnd_x, &wnd_y);
//  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
//  gtk_text_buffer_get_iter_at_mark(buffer, &iter,
//                                   gtk_text_buffer_get_insert(buffer));
//  gtk_text_view_get_iter_location(GTK_TEXT_VIEW(doc->textbox), &iter, &location);
//  gtk_text_view_buffer_to_window_coords(GTK_TEXT_VIEW(doc->textbox),
//                                        GTK_TEXT_WINDOW_TEXT,
//                                        location.x, location.y, &x, &y);
//  left_size = gtk_text_view_get_border_window_size(GTK_TEXT_VIEW(doc->textbox),
//                                                   GTK_TEXT_WINDOW_LEFT);
  gdk_window_get_size(cm_window->window, &wnd_width, &wnd_height);
  gtk_widget_realize(dialog);
  gdk_window_get_size(dialog->window, &dlg_width, &dlg_height);
  dlg_pos_x = wnd_x + wnd_width - dlg_width;
  dlg_pos_y = wnd_y + wnd_height - dlg_height;
//  gtk_widget_set_uposition(dialog, dlg_pos_x, dlg_pos_y);
  gtk_window_move(GTK_WINDOW(dialog), dlg_pos_x, dlg_pos_y);

  gtk_signal_connect(GTK_OBJECT(dialog), "key_press_event",
                     GTK_SIGNAL_FUNC(replace_dlg_key_cb), (gpointer)dialog);

  gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
  gtk_widget_show_all(dialog);
  gtk_main();

  return(replace_btn_ret);
}
