/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * Խ˽λ褦Ȥꡢ˥ե򳫤
 * ɽ롢ܥåΤδؿ
 */

/*
 * Cmemo : Text Editor
 * warning.c - source file for warning message
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include "cme_def.h"
#include "cmemo.h"
#include "warning.h"


static int value;

int dialog_destroy_cb(GtkWidget *widget, gpointer data)
{
  gtk_main_quit();
  return(0);
}

int yes_btn_cb(GtkWidget *widget, gpointer data)
{
  value = 0;
  gtk_widget_destroy(GTK_WIDGET(data));
  return(0);
}

int no_btn_cb(GtkWidget *widget, gpointer data)
{
  value = 1;
  gtk_widget_destroy(GTK_WIDGET(data));
  return(0);
}

gint warning_dlg_key_cb(GtkWidget *widget, GdkEvent *event, gpointer dialog)
{
  GdkEventKey *kevent = (GdkEventKey *)event;

  if (kevent->state == GDK_MOD1_MASK) {
    return(FALSE);
  }
  else {
    if (kevent->keyval == GDK_Y || kevent->keyval == GDK_y) {
      yes_btn_cb(widget, dialog);
    }
    else if (kevent->keyval == GDK_N || kevent->keyval == GDK_n) {
      no_btn_cb(widget, dialog);
    }
    else if (kevent->keyval == GDK_Escape || kevent->keyval == GDK_Cancel) {
      no_btn_cb(widget, dialog);
    }
    else {
      return(FALSE);
    }
  }
  return(TRUE);
}

/**************
 ٹ
 Yes 0 : No 1
 **************/
int warning(char *message)
{
  GtkWidget *w_dialog;
  GtkWidget *w_vbox;
  GtkWidget *w_hbox;
  GtkWidget *yes_btn;
  GtkWidget *no_btn;
  GtkWidget *w_label;
  int x;
  int y;
  int width;
  int height;
  int dlg_width;
  int dlg_height;
  int dlg_pos_x;
  int dlg_pos_y;

  value = 1;

  w_dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(w_dialog), "Warning!!");

  gtk_signal_connect(GTK_OBJECT(w_dialog), "destroy",
                     GTK_SIGNAL_FUNC(dialog_destroy_cb), NULL);

  w_vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(w_dialog), w_vbox);
  gtk_widget_show(w_vbox);

  w_label = gtk_label_new(message);
  gtk_box_pack_start(GTK_BOX(w_vbox), w_label, TRUE, TRUE, 0);
  gtk_widget_show(w_label);

  w_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(w_vbox), w_hbox, FALSE, FALSE, 0);
  gtk_widget_show(w_hbox);

  yes_btn = gtk_button_new_with_label("Yes");
  gtk_box_pack_start(GTK_BOX(w_hbox), yes_btn, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(yes_btn), "clicked",
                     GTK_SIGNAL_FUNC(yes_btn_cb), w_dialog);
  gtk_widget_show(yes_btn);
  gtk_widget_grab_focus(yes_btn);

  no_btn = gtk_button_new_with_label("No");
  gtk_box_pack_start(GTK_BOX(w_hbox), no_btn, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(no_btn), "clicked",
                     GTK_SIGNAL_FUNC(no_btn_cb), w_dialog);
  gtk_widget_show(no_btn);

  /* ᥤ󥦥ɥθ˱Ƥޤʤ褦 */
  gtk_window_set_transient_for(GTK_WINDOW(w_dialog), GTK_WINDOW(cm_window));

  /* ᥤ󥦥ɥ֤ */
  gdk_window_get_position(cm_window->window, &x, &y);
  gdk_window_get_size(cm_window->window, &width, &height);
  gtk_widget_realize(w_dialog);
  gdk_window_get_size(w_dialog->window, &dlg_width, &dlg_height);
  dlg_pos_x = x + (width - dlg_width) / 2;
  dlg_pos_y = y + (height - dlg_height) / 2;
  gtk_widget_set_uposition(w_dialog,
                           (dlg_pos_x > 0) ? dlg_pos_x : 0,
                           (dlg_pos_y > 0) ? dlg_pos_y : 0);

  gtk_signal_connect(GTK_OBJECT(w_dialog), "key_press_event",
                     GTK_SIGNAL_FUNC(warning_dlg_key_cb), (gpointer)w_dialog);

  /* ⡼ˤ */
  gtk_window_set_modal(GTK_WINDOW(w_dialog), TRUE);

  gtk_widget_show(w_dialog);

  gtk_main();

  return(value);
}
